use ::libc;

pub use crate::stddef_h::size_t;
pub use crate::stdlib::__int32_t;
pub use crate::stdlib::__uint32_t;
pub use crate::stdlib::__uint64_t;
pub use crate::stdlib::__uint8_t;
pub use crate::stdlib::__useconds_t;
pub use crate::stdlib::int32_t;

pub use crate::squeezelite_h::_buf_used;
pub use crate::squeezelite_h::buffer;
pub use crate::squeezelite_h::codec;
pub use crate::squeezelite_h::decode_state;
pub use crate::squeezelite_h::decodestate;
pub use crate::squeezelite_h::disconnect_code;
pub use crate::squeezelite_h::fade_dir;
pub use crate::squeezelite_h::fade_mode;
pub use crate::squeezelite_h::fade_state;
pub use crate::squeezelite_h::frames_t;
pub use crate::squeezelite_h::lDEBUG;
pub use crate::squeezelite_h::lERROR;
pub use crate::squeezelite_h::lINFO;
pub use crate::squeezelite_h::lSDEBUG;
pub use crate::squeezelite_h::lWARN;
pub use crate::squeezelite_h::log_level;
pub use crate::squeezelite_h::output_format;
pub use crate::squeezelite_h::output_state;
pub use crate::squeezelite_h::outputstate;
pub use crate::squeezelite_h::s32_t;
pub use crate::squeezelite_h::stream_state;
pub use crate::squeezelite_h::streamstate;
pub use crate::squeezelite_h::u32_t;
pub use crate::squeezelite_h::u64_t;
pub use crate::squeezelite_h::u8_t;
pub use crate::squeezelite_h::C2RustUnnamed_1;
pub use crate::squeezelite_h::DECODE_COMPLETE;
pub use crate::squeezelite_h::DECODE_ERROR;
pub use crate::squeezelite_h::DECODE_READY;
pub use crate::squeezelite_h::DECODE_RUNNING;
pub use crate::squeezelite_h::DECODE_STOPPED;
pub use crate::squeezelite_h::DISCONNECT;
pub use crate::squeezelite_h::DISCONNECT_OK;
pub use crate::squeezelite_h::FADE_ACTIVE;
pub use crate::squeezelite_h::FADE_CROSS;
pub use crate::squeezelite_h::FADE_CROSSFADE;
pub use crate::squeezelite_h::FADE_DOWN;
pub use crate::squeezelite_h::FADE_DUE;
pub use crate::squeezelite_h::FADE_IN;
pub use crate::squeezelite_h::FADE_INACTIVE;
pub use crate::squeezelite_h::FADE_INOUT;
pub use crate::squeezelite_h::FADE_NONE;
pub use crate::squeezelite_h::FADE_OUT;
pub use crate::squeezelite_h::FADE_UP;
pub use crate::squeezelite_h::LOCAL_DISCONNECT;
pub use crate::squeezelite_h::OUTPUT_BUFFER;
pub use crate::squeezelite_h::OUTPUT_OFF;
pub use crate::squeezelite_h::OUTPUT_PAUSE_FRAMES;
pub use crate::squeezelite_h::OUTPUT_RUNNING;
pub use crate::squeezelite_h::OUTPUT_SKIP_FRAMES;
pub use crate::squeezelite_h::OUTPUT_START_AT;
pub use crate::squeezelite_h::OUTPUT_STOPPED;
pub use crate::squeezelite_h::RECV_HEADERS;
pub use crate::squeezelite_h::REMOTE_DISCONNECT;
pub use crate::squeezelite_h::S16_LE;
pub use crate::squeezelite_h::S24_3LE;
pub use crate::squeezelite_h::S24_LE;
pub use crate::squeezelite_h::S32_LE;
pub use crate::squeezelite_h::SEND_HEADERS;
pub use crate::squeezelite_h::STOPPED;
pub use crate::squeezelite_h::STREAMING_BUFFERING;
pub use crate::squeezelite_h::STREAMING_FILE;
pub use crate::squeezelite_h::STREAMING_HTTP;
pub use crate::squeezelite_h::STREAMING_WAIT;
pub use crate::squeezelite_h::TIMEOUT;
pub use crate::squeezelite_h::UNREACHABLE;
pub use crate::src::buffer::_buf_space;
pub use crate::src::faad::register_faad;
pub use crate::src::flac::register_flac;
pub use crate::src::mad::register_mad;
pub use crate::src::mpg::register_mpg;
pub use crate::src::output::_checkfade;
pub use crate::src::pcm::register_pcm;
pub use crate::src::slimproto::wake_controller;
pub use crate::src::utils::logprint;
pub use crate::src::utils::logtime;
pub use crate::src::vorbis::register_vorbis;
pub use crate::stdlib::__pthread_internal_list;
pub use crate::stdlib::__pthread_list_t;
pub use crate::stdlib::__pthread_mutex_s;
use crate::stdlib::pthread_attr_destroy;
use crate::stdlib::pthread_attr_init;
use crate::stdlib::pthread_attr_setstacksize;
pub use crate::stdlib::pthread_attr_t;
use crate::stdlib::pthread_create;
use crate::stdlib::pthread_join;
use crate::stdlib::pthread_mutex_destroy;
use crate::stdlib::pthread_mutex_init;
use crate::stdlib::pthread_mutex_lock;
pub use crate::stdlib::pthread_mutex_t;
use crate::stdlib::pthread_mutex_unlock;
pub use crate::stdlib::pthread_mutexattr_t;
pub use crate::stdlib::pthread_t;
use crate::stdlib::strstr;
pub use crate::stdlib::u_int32_t;
pub use crate::stdlib::u_int64_t;
pub use crate::stdlib::u_int8_t;
use crate::stdlib::usleep;
extern "C" {
    #[no_mangle]
    pub static mut streambuf: *mut crate::squeezelite_h::buffer;
    #[no_mangle]
    pub static mut outputbuf: *mut crate::squeezelite_h::buffer;
    #[no_mangle]
    pub static mut stream: crate::squeezelite_h::streamstate;
    #[no_mangle]
    pub static mut output: crate::squeezelite_h::outputstate;
}
/*
 *  Squeezelite - lightweight headless squeezebox emulator
 *
 *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
 *      Ralph Irving 2015-2017, ralph_irving@hotmail.com
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
// decode thread
#[no_mangle]

pub static mut loglevel: crate::squeezelite_h::log_level = crate::squeezelite_h::lERROR;
#[no_mangle]

pub static mut decode: crate::squeezelite_h::decodestate = crate::squeezelite_h::decodestate {
    state: crate::squeezelite_h::DECODE_STOPPED,
    new_stream: false,
    mutex: crate::stdlib::pthread_mutex_t {
        __data: crate::stdlib::__pthread_mutex_s {
            __lock: 0,
            __count: 0,
            __owner: 0,
            __nusers: 0,
            __kind: 0,
            __spins: 0,
            __elision: 0,
            __list: crate::stdlib::__pthread_list_t {
                __prev: 0 as *const crate::stdlib::__pthread_internal_list
                    as *mut crate::stdlib::__pthread_internal_list,
                __next: 0 as *const crate::stdlib::__pthread_internal_list
                    as *mut crate::stdlib::__pthread_internal_list,
            },
        },
    },
};
#[no_mangle]

pub static mut codecs: [*mut crate::squeezelite_h::codec; 10] =
    [0 as *const crate::squeezelite_h::codec as *mut crate::squeezelite_h::codec; 10];
#[no_mangle]

pub static mut codec: *mut crate::squeezelite_h::codec =
    0 as *const crate::squeezelite_h::codec as *mut crate::squeezelite_h::codec;

static mut flac_container: crate::squeezelite_h::u8_t = '?' as i32 as crate::squeezelite_h::u8_t;

static mut running: bool = 1 as libc::c_int != 0;

unsafe extern "C" fn decode_thread() -> *mut libc::c_void {
    while running {
        let mut bytes: crate::stddef_h::size_t = 0;
        let mut space: crate::stddef_h::size_t = 0;
        let mut min_space: crate::stddef_h::size_t = 0;
        let mut toend: bool = false;
        let mut ran = 0 as libc::c_int != 0;
        crate::stdlib::pthread_mutex_lock(&mut (*streambuf).mutex);
        bytes = crate::squeezelite_h::_buf_used(streambuf) as crate::stddef_h::size_t;
        toend = stream.state as libc::c_uint
            <= crate::squeezelite_h::DISCONNECT as libc::c_int as libc::c_uint;
        crate::stdlib::pthread_mutex_unlock(&mut (*streambuf).mutex);
        crate::stdlib::pthread_mutex_lock(&mut (*outputbuf).mutex);
        space = crate::src::buffer::_buf_space(outputbuf) as crate::stddef_h::size_t;
        crate::stdlib::pthread_mutex_unlock(&mut (*outputbuf).mutex);
        crate::stdlib::pthread_mutex_lock(&mut decode.mutex);
        if decode.state as libc::c_uint
            == crate::squeezelite_h::DECODE_RUNNING as libc::c_int as libc::c_uint
            && !codec.is_null()
        {
            if loglevel as libc::c_uint
                >= crate::squeezelite_h::lSDEBUG as libc::c_int as libc::c_uint
            {
                crate::src::utils::logprint(
                    b"%s %s:%d streambuf bytes: %u outputbuf space: %u\n\x00" as *const u8
                        as *const libc::c_char,
                    crate::src::utils::logtime(),
                    (*::std::mem::transmute::<&[u8; 14], &[libc::c_char; 14]>(
                        b"decode_thread\x00",
                    ))
                    .as_ptr(),
                    76 as libc::c_int,
                    bytes,
                    space,
                );
            }
            min_space = (*codec).min_space as crate::stddef_h::size_t;
            if space > min_space
                && (bytes > (*codec).min_read_bytes as libc::c_ulong || toend as libc::c_int != 0)
            {
                decode.state = (*codec).decode.expect("non-null function pointer")();
                if decode.state as libc::c_uint
                    != crate::squeezelite_h::DECODE_RUNNING as libc::c_int as libc::c_uint
                {
                    if loglevel as libc::c_uint
                        >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint
                    {
                        crate::src::utils::logprint(
                            b"%s %s:%d decode %s\n\x00" as *const u8 as *const libc::c_char,
                            crate::src::utils::logtime(),
                            (*::std::mem::transmute::<&[u8; 14], &[libc::c_char; 14]>(
                                b"decode_thread\x00",
                            ))
                            .as_ptr(),
                            101 as libc::c_int,
                            if decode.state as libc::c_uint
                                == crate::squeezelite_h::DECODE_COMPLETE as libc::c_int
                                    as libc::c_uint
                            {
                                b"complete\x00" as *const u8 as *const libc::c_char
                            } else {
                                b"error\x00" as *const u8 as *const libc::c_char
                            },
                        );
                    }
                    crate::stdlib::pthread_mutex_lock(&mut (*outputbuf).mutex);
                    if output.fade_mode as u64 != 0 {
                        crate::src::output::_checkfade(0 as libc::c_int != 0);
                    }
                    crate::stdlib::pthread_mutex_unlock(&mut (*outputbuf).mutex);
                    crate::src::slimproto::wake_controller();
                }
                ran = 1 as libc::c_int != 0
            }
        }
        crate::stdlib::pthread_mutex_unlock(&mut decode.mutex);
        if !ran {
            crate::stdlib::usleep(100000 as libc::c_int as crate::stdlib::__useconds_t);
        }
    }
    return 0 as *mut libc::c_void;
}

unsafe extern "C" fn sort_codecs(mut pry: libc::c_int, mut ptr: *mut crate::squeezelite_h::codec) {
    static mut priority: [libc::c_int; 10] = [0; 10];
    let mut i: libc::c_int = 0;
    let mut tpry: libc::c_int = 0;
    let mut tptr = 0 as *mut crate::squeezelite_h::codec;
    i = 0 as libc::c_int;
    while i < 10 as libc::c_int {
        if codecs[i as usize].is_null() {
            codecs[i as usize] = ptr;
            priority[i as usize] = pry;
            return;
        }
        if pry < priority[i as usize] {
            tptr = codecs[i as usize];
            codecs[i as usize] = ptr;
            ptr = tptr;
            tpry = priority[i as usize];
            priority[i as usize] = pry;
            pry = tpry
        }
        i += 1
    }
}

static mut thread: crate::stdlib::pthread_t = 0;
#[no_mangle]

pub unsafe extern "C" fn decode_init(
    mut level: crate::squeezelite_h::log_level,
    mut include_codecs: *const libc::c_char,
    mut exclude_codecs: *const libc::c_char,
) {
    let mut i: libc::c_int = 0;
    let mut order_codecs = 0 as *mut libc::c_char;
    loglevel = level;
    if loglevel as libc::c_uint >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint {
        crate::src::utils::logprint(
            b"%s %s:%d init decode\n\x00" as *const u8 as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 12], &[libc::c_char; 12]>(b"decode_init\x00")).as_ptr(),
            154 as libc::c_int,
        );
    }
    // register codecs
    // dsf,dff,alc,wma,wmap,wmal,aac,spt,ogg,ogf,flc,aif,pcm,mp3
    i = 0 as libc::c_int;
    if crate::stdlib::strstr(
        exclude_codecs,
        b"aac\x00" as *const u8 as *const libc::c_char,
    )
    .is_null()
        && (include_codecs.is_null() || {
            order_codecs = crate::stdlib::strstr(
                include_codecs,
                b"aac\x00" as *const u8 as *const libc::c_char,
            );
            !order_codecs.is_null()
        })
    {
        sort_codecs(
            if !include_codecs.is_null() {
                order_codecs.wrapping_offset_from(include_codecs) as libc::c_long
            } else {
                i as libc::c_long
            } as libc::c_int,
            crate::src::faad::register_faad(),
        );
    }
    if crate::stdlib::strstr(
        exclude_codecs,
        b"ogg\x00" as *const u8 as *const libc::c_char,
    )
    .is_null()
        && (include_codecs.is_null() || {
            order_codecs = crate::stdlib::strstr(
                include_codecs,
                b"ogg\x00" as *const u8 as *const libc::c_char,
            );
            !order_codecs.is_null()
        })
    {
        sort_codecs(
            if !include_codecs.is_null() {
                order_codecs.wrapping_offset_from(include_codecs) as libc::c_long
            } else {
                i as libc::c_long
            } as libc::c_int,
            crate::src::vorbis::register_vorbis(),
        );
    }
    if crate::stdlib::strstr(
        exclude_codecs,
        b"flac\x00" as *const u8 as *const libc::c_char,
    )
    .is_null()
        && (include_codecs.is_null() || {
            order_codecs = crate::stdlib::strstr(
                include_codecs,
                b"flac\x00" as *const u8 as *const libc::c_char,
            );
            !order_codecs.is_null()
        })
    {
        sort_codecs(
            if !include_codecs.is_null() {
                order_codecs.wrapping_offset_from(include_codecs) as libc::c_long
            } else {
                i as libc::c_long
            } as libc::c_int,
            crate::src::flac::register_flac(),
        );
    }
    if crate::stdlib::strstr(
        exclude_codecs,
        b"pcm\x00" as *const u8 as *const libc::c_char,
    )
    .is_null()
        && (include_codecs.is_null() || {
            order_codecs = crate::stdlib::strstr(
                include_codecs,
                b"pcm\x00" as *const u8 as *const libc::c_char,
            );
            !order_codecs.is_null()
        })
    {
        sort_codecs(
            if !include_codecs.is_null() {
                order_codecs.wrapping_offset_from(include_codecs) as libc::c_long
            } else {
                i as libc::c_long
            } as libc::c_int,
            crate::src::pcm::register_pcm(),
        );
    }
    // try mad then mpg for mp3 unless command line option passed
    if !(!crate::stdlib::strstr(
        exclude_codecs,
        b"mp3\x00" as *const u8 as *const libc::c_char,
    )
    .is_null()
        || !crate::stdlib::strstr(
            exclude_codecs,
            b"mad\x00" as *const u8 as *const libc::c_char,
        )
        .is_null())
        && (include_codecs.is_null()
            || {
                order_codecs = crate::stdlib::strstr(
                    include_codecs,
                    b"mp3\x00" as *const u8 as *const libc::c_char,
                );
                !order_codecs.is_null()
            }
            || {
                order_codecs = crate::stdlib::strstr(
                    include_codecs,
                    b"mad\x00" as *const u8 as *const libc::c_char,
                );
                !order_codecs.is_null()
            })
    {
        sort_codecs(
            if !include_codecs.is_null() {
                order_codecs.wrapping_offset_from(include_codecs) as libc::c_long
            } else {
                i as libc::c_long
            } as libc::c_int,
            crate::src::mad::register_mad(),
        );
    } else if !(!crate::stdlib::strstr(
        exclude_codecs,
        b"mp3\x00" as *const u8 as *const libc::c_char,
    )
    .is_null()
        || !crate::stdlib::strstr(
            exclude_codecs,
            b"mpg\x00" as *const u8 as *const libc::c_char,
        )
        .is_null())
        && (include_codecs.is_null()
            || {
                order_codecs = crate::stdlib::strstr(
                    include_codecs,
                    b"mp3\x00" as *const u8 as *const libc::c_char,
                );
                !order_codecs.is_null()
            }
            || {
                order_codecs = crate::stdlib::strstr(
                    include_codecs,
                    b"mpg\x00" as *const u8 as *const libc::c_char,
                );
                !order_codecs.is_null()
            })
    {
        sort_codecs(
            if !include_codecs.is_null() {
                order_codecs.wrapping_offset_from(include_codecs) as libc::c_long
            } else {
                i as libc::c_long
            } as libc::c_int,
            crate::src::mpg::register_mpg(),
        );
    }
    if loglevel as libc::c_uint >= crate::squeezelite_h::lDEBUG as libc::c_int as libc::c_uint {
        crate::src::utils::logprint(
            b"%s %s:%d include codecs: %s exclude codecs: %s\n\x00" as *const u8
                as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 12], &[libc::c_char; 12]>(b"decode_init\x00")).as_ptr(),
            195 as libc::c_int,
            if !include_codecs.is_null() {
                include_codecs
            } else {
                b"\x00" as *const u8 as *const libc::c_char
            },
            exclude_codecs,
        );
    }
    crate::stdlib::pthread_mutex_init(
        &mut decode.mutex,
        0 as *const crate::stdlib::pthread_mutexattr_t,
    );
    let mut attr = crate::stdlib::pthread_attr_t { __size: [0; 56] };
    crate::stdlib::pthread_attr_init(&mut attr);
    crate::stdlib::pthread_attr_setstacksize(
        &mut attr,
        (16384 as libc::c_int + 128 as libc::c_int * 1024 as libc::c_int)
            as crate::stddef_h::size_t,
    );
    crate::stdlib::pthread_create(
        &mut thread,
        &mut attr,
        ::std::mem::transmute::<
            Option<unsafe extern "C" fn() -> *mut libc::c_void>,
            Option<unsafe extern "C" fn(_: *mut libc::c_void) -> *mut libc::c_void>,
        >(Some(::std::mem::transmute::<
            unsafe extern "C" fn() -> *mut libc::c_void,
            unsafe extern "C" fn() -> *mut libc::c_void,
        >(decode_thread))),
        0 as *mut libc::c_void,
    );
    crate::stdlib::pthread_attr_destroy(&mut attr);
    decode.new_stream = 1 as libc::c_int != 0;
    decode.state = crate::squeezelite_h::DECODE_STOPPED;
}
#[no_mangle]

pub unsafe extern "C" fn decode_close() {
    if loglevel as libc::c_uint >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint {
        crate::src::utils::logprint(
            b"%s %s:%d close decode\n\x00" as *const u8 as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 13], &[libc::c_char; 13]>(b"decode_close\x00"))
                .as_ptr(),
            222 as libc::c_int,
        );
    }
    crate::stdlib::pthread_mutex_lock(&mut decode.mutex);
    if !codec.is_null() {
        (*codec).close.expect("non-null function pointer")();
        codec = 0 as *mut crate::squeezelite_h::codec
    }
    running = 0 as libc::c_int != 0;
    crate::stdlib::pthread_mutex_unlock(&mut decode.mutex);
    crate::stdlib::pthread_join(thread, 0 as *mut *mut libc::c_void);
    crate::stdlib::pthread_mutex_destroy(&mut decode.mutex);
}
#[no_mangle]

pub unsafe extern "C" fn decode_flush() {
    if loglevel as libc::c_uint >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint {
        crate::src::utils::logprint(
            b"%s %s:%d decode flush\n\x00" as *const u8 as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 13], &[libc::c_char; 13]>(b"decode_flush\x00"))
                .as_ptr(),
            237 as libc::c_int,
        );
    }
    crate::stdlib::pthread_mutex_lock(&mut decode.mutex);
    decode.state = crate::squeezelite_h::DECODE_STOPPED;
    crate::stdlib::pthread_mutex_unlock(&mut decode.mutex);
}
#[no_mangle]

pub unsafe extern "C" fn decode_newstream(
    mut sample_rate: libc::c_uint,
    mut supported_rates: *mut libc::c_uint,
) -> libc::c_uint {
    // called with O locked to get sample rate for potentially processed output stream
    // release O mutex during process_newstream as it can take some time
    return sample_rate;
}
/*
 *  Squeezelite - lightweight headless squeezebox emulator
 *
 *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
 *      Ralph Irving 2015-2017, ralph_irving@hotmail.com
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additions (c) Paul Hermann, 2015-2017 under the same license terms
 *   -Control of Raspberry pi GPIO for amplifier power
 *   -Launch script on power status change from LMS
 */
// make may define: PORTAUDIO, SELFPIPE, RESAMPLE, RESAMPLE_MP, VISEXPORT, GPIO, IR, DSD, LINKALL to influence build
// build detection
// dynamically loaded libraries at run time
// !LINKALL
// config options
// do not reduce as icy-meta max is 4080
/* SUN */
/* SUN */
// printf/scanf formats for u64_t
// logging
// utils.c (non logging)
// buffer.c
// _* called with mutex locked
// slimproto.c
// stream.c
// decode.c
#[no_mangle]

pub unsafe extern "C" fn codec_open(
    mut format: crate::squeezelite_h::u8_t,
    mut sample_size: crate::squeezelite_h::u8_t,
    mut sample_rate: crate::squeezelite_h::u8_t,
    mut channels: crate::squeezelite_h::u8_t,
    mut endianness: crate::squeezelite_h::u8_t,
) {
    let mut i: libc::c_int = 0;
    if loglevel as libc::c_uint >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint {
        crate::src::utils::logprint(
            b"%s %s:%d codec open: \'%c\'\n\x00" as *const u8 as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 11], &[libc::c_char; 11]>(b"codec_open\x00")).as_ptr(),
            265 as libc::c_int,
            format as libc::c_int,
        );
    }
    crate::stdlib::pthread_mutex_lock(&mut decode.mutex);
    decode.new_stream = 1 as libc::c_int != 0;
    decode.state = crate::squeezelite_h::DECODE_STOPPED;
    // potentially changed within codec when processing enabled
    // find the required codec
    i = 0 as libc::c_int;
    while i < 10 as libc::c_int {
        if !codecs[i as usize].is_null()
            && (*codecs[i as usize]).id as libc::c_int == format as libc::c_int
        {
            // close codec if format or flac container changed
            if !codec.is_null()
                && (codec != codecs[i as usize]
                    || (*codecs[i as usize]).id as libc::c_int == 'f' as i32
                        && flac_container as libc::c_int != sample_size as libc::c_int)
            {
                if loglevel as libc::c_uint
                    >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint
                {
                    crate::src::utils::logprint(
                        b"%s %s:%d closing codec: \'%c\'\n\x00" as *const u8 as *const libc::c_char,
                        crate::src::utils::logtime(),
                        (*::std::mem::transmute::<&[u8; 11], &[libc::c_char; 11]>(
                            b"codec_open\x00",
                        ))
                        .as_ptr(),
                        283 as libc::c_int,
                        (*codec).id as libc::c_int,
                    );
                }
                (*codec).close.expect("non-null function pointer")();
            }
            codec = codecs[i as usize];
            if (*codec).id as libc::c_int == 'f' as i32 {
                flac_container = sample_size
            }
            (*codec).open.expect("non-null function pointer")(
                sample_size,
                sample_rate,
                channels,
                endianness,
            );
            decode.state = crate::squeezelite_h::DECODE_READY;
            crate::stdlib::pthread_mutex_unlock(&mut decode.mutex);
            return;
        }
        i += 1
    }
    crate::stdlib::pthread_mutex_unlock(&mut decode.mutex);
    crate::src::utils::logprint(
        b"%s %s:%d codec not found\n\x00" as *const u8 as *const libc::c_char,
        crate::src::utils::logtime(),
        (*::std::mem::transmute::<&[u8; 11], &[libc::c_char; 11]>(b"codec_open\x00")).as_ptr(),
        303 as libc::c_int,
    );
}
