use ::libc;

pub use crate::stddef_h::size_t;
pub use crate::stdlib::__int32_t;
pub use crate::stdlib::__uint32_t;
pub use crate::stdlib::__uint64_t;
pub use crate::stdlib::__uint8_t;
pub use crate::stdlib::int32_t;

pub use crate::stdlib::__pthread_internal_list;
pub use crate::stdlib::__pthread_list_t;
pub use crate::stdlib::__pthread_mutex_s;
pub use crate::stdlib::pthread_mutex_t;
pub use crate::stdlib::u_int32_t;
pub use crate::stdlib::u_int64_t;
pub use crate::stdlib::u_int8_t;

pub use crate::squeezelite_h::buffer;
pub use crate::squeezelite_h::codec;
pub use crate::squeezelite_h::decode_state;
pub use crate::squeezelite_h::decodestate;
pub use crate::squeezelite_h::disconnect_code;
pub use crate::squeezelite_h::fade_dir;
pub use crate::squeezelite_h::fade_mode;
pub use crate::squeezelite_h::fade_state;
pub use crate::squeezelite_h::frames_t;
pub use crate::squeezelite_h::lDEBUG;
pub use crate::squeezelite_h::lERROR;
pub use crate::squeezelite_h::lINFO;
pub use crate::squeezelite_h::lSDEBUG;
pub use crate::squeezelite_h::lWARN;
pub use crate::squeezelite_h::log_level;
pub use crate::squeezelite_h::output_format;
pub use crate::squeezelite_h::output_state;
pub use crate::squeezelite_h::outputstate;
pub use crate::squeezelite_h::s32_t;
pub use crate::squeezelite_h::stream_state;
pub use crate::squeezelite_h::streamstate;
pub use crate::squeezelite_h::u32_t;
pub use crate::squeezelite_h::u64_t;
pub use crate::squeezelite_h::u8_t;
pub use crate::squeezelite_h::C2RustUnnamed_1;
pub use crate::squeezelite_h::_buf_used;
pub use crate::squeezelite_h::DECODE_COMPLETE;
pub use crate::squeezelite_h::DECODE_ERROR;
pub use crate::squeezelite_h::DECODE_READY;
pub use crate::squeezelite_h::DECODE_RUNNING;
pub use crate::squeezelite_h::DECODE_STOPPED;
pub use crate::squeezelite_h::DISCONNECT;
pub use crate::squeezelite_h::DISCONNECT_OK;
pub use crate::squeezelite_h::FADE_ACTIVE;
pub use crate::squeezelite_h::FADE_CROSS;
pub use crate::squeezelite_h::FADE_CROSSFADE;
pub use crate::squeezelite_h::FADE_DOWN;
pub use crate::squeezelite_h::FADE_DUE;
pub use crate::squeezelite_h::FADE_IN;
pub use crate::squeezelite_h::FADE_INACTIVE;
pub use crate::squeezelite_h::FADE_INOUT;
pub use crate::squeezelite_h::FADE_NONE;
pub use crate::squeezelite_h::FADE_OUT;
pub use crate::squeezelite_h::FADE_UP;
pub use crate::squeezelite_h::LOCAL_DISCONNECT;
pub use crate::squeezelite_h::OUTPUT_BUFFER;
pub use crate::squeezelite_h::OUTPUT_OFF;
pub use crate::squeezelite_h::OUTPUT_PAUSE_FRAMES;
pub use crate::squeezelite_h::OUTPUT_RUNNING;
pub use crate::squeezelite_h::OUTPUT_SKIP_FRAMES;
pub use crate::squeezelite_h::OUTPUT_START_AT;
pub use crate::squeezelite_h::OUTPUT_STOPPED;
pub use crate::squeezelite_h::RECV_HEADERS;
pub use crate::squeezelite_h::REMOTE_DISCONNECT;
pub use crate::squeezelite_h::S16_LE;
pub use crate::squeezelite_h::S24_3LE;
pub use crate::squeezelite_h::S24_LE;
pub use crate::squeezelite_h::S32_LE;
pub use crate::squeezelite_h::SEND_HEADERS;
pub use crate::squeezelite_h::STOPPED;
pub use crate::squeezelite_h::STREAMING_BUFFERING;
pub use crate::squeezelite_h::STREAMING_FILE;
pub use crate::squeezelite_h::STREAMING_HTTP;
pub use crate::squeezelite_h::STREAMING_WAIT;
pub use crate::squeezelite_h::TIMEOUT;
pub use crate::squeezelite_h::UNREACHABLE;
pub use crate::src::buffer::_buf_cont_read;
pub use crate::src::buffer::_buf_cont_write;
pub use crate::src::buffer::_buf_inc_readp;
pub use crate::src::buffer::_buf_inc_writep;
pub use crate::src::buffer::_buf_space;
pub use crate::src::buffer::buf_adjust;
pub use crate::src::decode::decode_newstream;
pub use crate::src::output::_checkfade;
pub use crate::src::utils::logprint;
pub use crate::src::utils::logtime;
use crate::stdlib::memcmp;
use crate::stdlib::memcpy;
use crate::stdlib::pthread_mutex_lock;
use crate::stdlib::pthread_mutex_unlock;
extern "C" {
    /*
     *  Squeezelite - lightweight headless squeezebox emulator
     *
     *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
     *      Ralph Irving 2015-2017, ralph_irving@hotmail.com
     *
     * This program is free software: you can redistribute it and/or modify
     * it under the terms of the GNU General Public License as published by
     * the Free Software Foundation, either version 3 of the License, or
     * (at your option) any later version.
     *
     * This program is distributed in the hope that it will be useful,
     * but WITHOUT ANY WARRANTY; without even the implied warranty of
     * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     * GNU General Public License for more details.
     *
     * You should have received a copy of the GNU General Public License
     * along with this program.  If not, see <http://www.gnu.org/licenses/>.
     *
     */
    #[no_mangle]
    pub static mut loglevel: crate::squeezelite_h::log_level;
    #[no_mangle]
    pub static mut streambuf: *mut crate::squeezelite_h::buffer;
    #[no_mangle]
    pub static mut outputbuf: *mut crate::squeezelite_h::buffer;
    #[no_mangle]
    pub static mut stream: crate::squeezelite_h::streamstate;
    #[no_mangle]
    pub static mut output: crate::squeezelite_h::outputstate;
    #[no_mangle]
    pub static mut decode: crate::squeezelite_h::decodestate;
}

pub const AIFF: header_format = 2;

pub type header_format = libc::c_uint;

pub const WAVE: header_format = 1;

pub const UNKNOWN: header_format = 0;
#[no_mangle]

pub static mut pcm_check_header: bool = 0 as libc::c_int != 0;

static mut sample_rates: [crate::squeezelite_h::u32_t; 17] = [
    11025 as libc::c_int as crate::squeezelite_h::u32_t,
    22050 as libc::c_int as crate::squeezelite_h::u32_t,
    32000 as libc::c_int as crate::squeezelite_h::u32_t,
    44100 as libc::c_int as crate::squeezelite_h::u32_t,
    48000 as libc::c_int as crate::squeezelite_h::u32_t,
    8000 as libc::c_int as crate::squeezelite_h::u32_t,
    12000 as libc::c_int as crate::squeezelite_h::u32_t,
    16000 as libc::c_int as crate::squeezelite_h::u32_t,
    24000 as libc::c_int as crate::squeezelite_h::u32_t,
    96000 as libc::c_int as crate::squeezelite_h::u32_t,
    88200 as libc::c_int as crate::squeezelite_h::u32_t,
    176400 as libc::c_int as crate::squeezelite_h::u32_t,
    192000 as libc::c_int as crate::squeezelite_h::u32_t,
    352800 as libc::c_int as crate::squeezelite_h::u32_t,
    384000 as libc::c_int as crate::squeezelite_h::u32_t,
    705600 as libc::c_int as crate::squeezelite_h::u32_t,
    768000 as libc::c_int as crate::squeezelite_h::u32_t,
];

static mut sample_rate: crate::squeezelite_h::u32_t = 0;

static mut sample_size: crate::squeezelite_h::u32_t = 0;

static mut channels: crate::squeezelite_h::u32_t = 0;

static mut bigendian: bool = false;

static mut limit: bool = false;

static mut audio_left: crate::squeezelite_h::u32_t = 0;

static mut bytes_per_frame: crate::squeezelite_h::u32_t = 0;

unsafe extern "C" fn _check_header() {
    let mut ptr = (*streambuf).readp;
    let mut bytes = if crate::squeezelite_h::_buf_used(streambuf)
        < crate::src::buffer::_buf_cont_read(streambuf)
    {
        crate::squeezelite_h::_buf_used(streambuf)
    } else {
        crate::src::buffer::_buf_cont_read(streambuf)
    };
    let mut format = UNKNOWN;
    // simple parsing of wav and aiff headers and get to samples
    if bytes > 12 as libc::c_int as libc::c_uint {
        if crate::stdlib::memcmp(
            ptr as *const libc::c_void,
            b"RIFF\x00" as *const u8 as *const libc::c_char as *const libc::c_void,
            4 as libc::c_int as libc::c_ulong,
        ) == 0
            && crate::stdlib::memcmp(
                ptr.offset(8 as libc::c_int as isize) as *const libc::c_void,
                b"WAVE\x00" as *const u8 as *const libc::c_char as *const libc::c_void,
                4 as libc::c_int as libc::c_ulong,
            ) == 0
        {
            if loglevel as libc::c_uint
                >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint
            {
                crate::src::utils::logprint(
                    b"%s %s:%d WAVE\n\x00" as *const u8 as *const libc::c_char,
                    crate::src::utils::logtime(),
                    (*::std::mem::transmute::<&[u8; 14], &[libc::c_char; 14]>(
                        b"_check_header\x00",
                    ))
                    .as_ptr(),
                    80 as libc::c_int,
                );
            }
            format = WAVE
        } else if crate::stdlib::memcmp(
            ptr as *const libc::c_void,
            b"FORM\x00" as *const u8 as *const libc::c_char as *const libc::c_void,
            4 as libc::c_int as libc::c_ulong,
        ) == 0
            && (crate::stdlib::memcmp(
                ptr.offset(8 as libc::c_int as isize) as *const libc::c_void,
                b"AIFF\x00" as *const u8 as *const libc::c_char as *const libc::c_void,
                4 as libc::c_int as libc::c_ulong,
            ) == 0
                || crate::stdlib::memcmp(
                    ptr.offset(8 as libc::c_int as isize) as *const libc::c_void,
                    b"AIFC\x00" as *const u8 as *const libc::c_char as *const libc::c_void,
                    4 as libc::c_int as libc::c_ulong,
                ) == 0)
        {
            if loglevel as libc::c_uint
                >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint
            {
                crate::src::utils::logprint(
                    b"%s %s:%d AIFF\n\x00" as *const u8 as *const libc::c_char,
                    crate::src::utils::logtime(),
                    (*::std::mem::transmute::<&[u8; 14], &[libc::c_char; 14]>(
                        b"_check_header\x00",
                    ))
                    .as_ptr(),
                    83 as libc::c_int,
                );
            }
            format = AIFF
        }
    }
    if format as libc::c_uint != UNKNOWN as libc::c_int as libc::c_uint {
        ptr = ptr.offset(12 as libc::c_int as isize);
        bytes = bytes.wrapping_sub(12 as libc::c_int as libc::c_uint);
        while bytes >= 8 as libc::c_int as libc::c_uint {
            let mut id: [libc::c_char; 5] = [0; 5];
            let mut len: libc::c_uint = 0;
            crate::stdlib::memcpy(
                id.as_mut_ptr() as *mut libc::c_void,
                ptr as *const libc::c_void,
                4 as libc::c_int as libc::c_ulong,
            );
            id[4 as libc::c_int as usize] = '\u{0}' as i32 as libc::c_char;
            if format as libc::c_uint == WAVE as libc::c_int as libc::c_uint {
                len = (*ptr.offset(4 as libc::c_int as isize) as libc::c_int
                    | (*ptr.offset(5 as libc::c_int as isize) as libc::c_int) << 8 as libc::c_int
                    | (*ptr.offset(6 as libc::c_int as isize) as libc::c_int) << 16 as libc::c_int
                    | (*ptr.offset(7 as libc::c_int as isize) as libc::c_int) << 24 as libc::c_int)
                    as libc::c_uint
            } else {
                len = ((*ptr.offset(4 as libc::c_int as isize) as libc::c_int) << 24 as libc::c_int
                    | (*ptr.offset(5 as libc::c_int as isize) as libc::c_int) << 16 as libc::c_int
                    | (*ptr.offset(6 as libc::c_int as isize) as libc::c_int) << 8 as libc::c_int
                    | *ptr.offset(7 as libc::c_int as isize) as libc::c_int)
                    as libc::c_uint
            }
            if loglevel as libc::c_uint
                >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint
            {
                crate::src::utils::logprint(
                    b"%s %s:%d header: %s len: %d\n\x00" as *const u8 as *const libc::c_char,
                    crate::src::utils::logtime(),
                    (*::std::mem::transmute::<&[u8; 14], &[libc::c_char; 14]>(
                        b"_check_header\x00",
                    ))
                    .as_ptr(),
                    104 as libc::c_int,
                    id.as_mut_ptr(),
                    len,
                );
            }
            if format as libc::c_uint == WAVE as libc::c_int as libc::c_uint
                && crate::stdlib::memcmp(
                    ptr as *const libc::c_void,
                    b"data\x00" as *const u8 as *const libc::c_char as *const libc::c_void,
                    4 as libc::c_int as libc::c_ulong,
                ) == 0
            {
                ptr = ptr.offset(8 as libc::c_int as isize);
                crate::src::buffer::_buf_inc_readp(
                    streambuf,
                    ptr.wrapping_offset_from((*streambuf).readp) as libc::c_long as libc::c_uint,
                );
                audio_left = len;
                if audio_left == 0xffffffff as libc::c_uint
                    || audio_left == 0x7fffeffc as libc::c_int as libc::c_uint
                {
                    if loglevel as libc::c_uint
                        >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint
                    {
                        crate::src::utils::logprint(
                            b"%s %s:%d wav audio size unknown: %u\n\x00" as *const u8
                                as *const libc::c_char,
                            crate::src::utils::logtime(),
                            (*::std::mem::transmute::<&[u8; 14], &[libc::c_char; 14]>(
                                b"_check_header\x00",
                            ))
                            .as_ptr(),
                            112 as libc::c_int,
                            audio_left,
                        );
                    }
                    limit = 0 as libc::c_int != 0
                } else {
                    if loglevel as libc::c_uint
                        >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint
                    {
                        crate::src::utils::logprint(
                            b"%s %s:%d wav audio size: %u\n\x00" as *const u8
                                as *const libc::c_char,
                            crate::src::utils::logtime(),
                            (*::std::mem::transmute::<&[u8; 14], &[libc::c_char; 14]>(
                                b"_check_header\x00",
                            ))
                            .as_ptr(),
                            115 as libc::c_int,
                            audio_left,
                        );
                    }
                    limit = 1 as libc::c_int != 0
                }
                return;
            }
            if format as libc::c_uint == AIFF as libc::c_int as libc::c_uint
                && crate::stdlib::memcmp(
                    ptr as *const libc::c_void,
                    b"SSND\x00" as *const u8 as *const libc::c_char as *const libc::c_void,
                    4 as libc::c_int as libc::c_ulong,
                ) == 0
                && bytes >= 16 as libc::c_int as libc::c_uint
            {
                let mut offset = ((*ptr.offset(8 as libc::c_int as isize) as libc::c_int)
                    << 24 as libc::c_int
                    | (*ptr.offset(9 as libc::c_int as isize) as libc::c_int) << 16 as libc::c_int
                    | (*ptr.offset(10 as libc::c_int as isize) as libc::c_int) << 8 as libc::c_int
                    | *ptr.offset(11 as libc::c_int as isize) as libc::c_int)
                    as libc::c_uint;
                // following 4 bytes is blocksize - ignored
                ptr = ptr.offset((8 as libc::c_int + 8 as libc::c_int) as isize);
                crate::src::buffer::_buf_inc_readp(
                    streambuf,
                    ptr.offset(offset as isize)
                        .wrapping_offset_from((*streambuf).readp)
                        as libc::c_long as libc::c_uint,
                );
                // Reading from an upsampled stream, length could be wrong.
                // Only use length in header for files.
                if stream.state as libc::c_uint
                    == crate::squeezelite_h::STREAMING_FILE as libc::c_int as libc::c_uint
                {
                    audio_left = len
                        .wrapping_sub(8 as libc::c_int as libc::c_uint)
                        .wrapping_sub(offset);
                    if loglevel as libc::c_uint
                        >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint
                    {
                        crate::src::utils::logprint(
                            b"%s %s:%d aif audio size: %u\n\x00" as *const u8
                                as *const libc::c_char,
                            crate::src::utils::logtime(),
                            (*::std::mem::transmute::<&[u8; 14], &[libc::c_char; 14]>(
                                b"_check_header\x00",
                            ))
                            .as_ptr(),
                            131 as libc::c_int,
                            audio_left,
                        );
                    }
                    limit = 1 as libc::c_int != 0
                }
                return;
            }
            if format as libc::c_uint == WAVE as libc::c_int as libc::c_uint
                && crate::stdlib::memcmp(
                    ptr as *const libc::c_void,
                    b"fmt \x00" as *const u8 as *const libc::c_char as *const libc::c_void,
                    4 as libc::c_int as libc::c_ulong,
                ) == 0
                && bytes >= 24 as libc::c_int as libc::c_uint
            {
                // override the server parsed values with our own
                channels = (*ptr.offset(10 as libc::c_int as isize) as libc::c_int
                    | (*ptr.offset(11 as libc::c_int as isize) as libc::c_int) << 8 as libc::c_int)
                    as crate::squeezelite_h::u32_t;
                sample_rate = (*ptr.offset(12 as libc::c_int as isize) as libc::c_int
                    | (*ptr.offset(13 as libc::c_int as isize) as libc::c_int) << 8 as libc::c_int
                    | (*ptr.offset(14 as libc::c_int as isize) as libc::c_int) << 16 as libc::c_int
                    | (*ptr.offset(15 as libc::c_int as isize) as libc::c_int) << 24 as libc::c_int)
                    as crate::squeezelite_h::u32_t;
                sample_size = ((*ptr.offset(22 as libc::c_int as isize) as libc::c_int
                    | (*ptr.offset(23 as libc::c_int as isize) as libc::c_int) << 8 as libc::c_int)
                    / 8 as libc::c_int)
                    as crate::squeezelite_h::u32_t;
                bigendian = 0 as libc::c_int != 0;
                if loglevel as libc::c_uint
                    >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint
                {
                    crate::src::utils::logprint(
                        b"%s %s:%d pcm size: %u rate: %u chan: %u bigendian: %u\n\x00" as *const u8
                            as *const libc::c_char,
                        crate::src::utils::logtime(),
                        (*::std::mem::transmute::<&[u8; 14], &[libc::c_char; 14]>(
                            b"_check_header\x00",
                        ))
                        .as_ptr(),
                        143 as libc::c_int,
                        sample_size,
                        sample_rate,
                        channels,
                        bigendian as libc::c_int,
                    );
                }
            }
            if format as libc::c_uint == AIFF as libc::c_int as libc::c_uint
                && crate::stdlib::memcmp(
                    ptr as *const libc::c_void,
                    b"COMM\x00" as *const u8 as *const libc::c_char as *const libc::c_void,
                    4 as libc::c_int as libc::c_ulong,
                ) == 0
                && bytes >= 26 as libc::c_int as libc::c_uint
            {
                let mut exponent: libc::c_int = 0;
                // override the server parsed values with our own
                channels = ((*ptr.offset(8 as libc::c_int as isize) as libc::c_int)
                    << 8 as libc::c_int
                    | *ptr.offset(9 as libc::c_int as isize) as libc::c_int)
                    as crate::squeezelite_h::u32_t;
                sample_size =
                    (((*ptr.offset(14 as libc::c_int as isize) as libc::c_int) << 8 as libc::c_int
                        | *ptr.offset(15 as libc::c_int as isize) as libc::c_int)
                        / 8 as libc::c_int) as crate::squeezelite_h::u32_t;
                bigendian = 1 as libc::c_int != 0;
                // sample rate is encoded as IEEE 80 bit extended format
                // make some assumptions to simplify processing - only use first 32 bits of mantissa
                exponent = ((*ptr.offset(16 as libc::c_int as isize) as libc::c_int
                    & 0x7f as libc::c_int)
                    << 8 as libc::c_int
                    | *ptr.offset(17 as libc::c_int as isize) as libc::c_int)
                    - 16383 as libc::c_int
                    - 31 as libc::c_int;
                sample_rate = ((*ptr.offset(18 as libc::c_int as isize) as libc::c_int)
                    << 24 as libc::c_int
                    | (*ptr.offset(19 as libc::c_int as isize) as libc::c_int) << 16 as libc::c_int
                    | (*ptr.offset(20 as libc::c_int as isize) as libc::c_int) << 8 as libc::c_int
                    | *ptr.offset(21 as libc::c_int as isize) as libc::c_int)
                    as crate::squeezelite_h::u32_t;
                while exponent < 0 as libc::c_int {
                    sample_rate >>= 1 as libc::c_int;
                    exponent += 1
                }
                while exponent > 0 as libc::c_int {
                    sample_rate <<= 1 as libc::c_int;
                    exponent -= 1
                }
                if loglevel as libc::c_uint
                    >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint
                {
                    crate::src::utils::logprint(
                        b"%s %s:%d pcm size: %u rate: %u chan: %u bigendian: %u\n\x00" as *const u8
                            as *const libc::c_char,
                        crate::src::utils::logtime(),
                        (*::std::mem::transmute::<&[u8; 14], &[libc::c_char; 14]>(
                            b"_check_header\x00",
                        ))
                        .as_ptr(),
                        158 as libc::c_int,
                        sample_size,
                        sample_rate,
                        channels,
                        bigendian as libc::c_int,
                    );
                }
            }
            if bytes >= len.wrapping_add(8 as libc::c_int as libc::c_uint) {
                ptr = ptr.offset(len.wrapping_add(8 as libc::c_int as libc::c_uint) as isize);
                bytes = bytes.wrapping_sub(len.wrapping_add(8 as libc::c_int as libc::c_uint))
            } else {
                if loglevel as libc::c_uint
                    >= crate::squeezelite_h::lWARN as libc::c_int as libc::c_uint
                {
                    crate::src::utils::logprint(
                        b"%s %s:%d run out of data\n\x00" as *const u8 as *const libc::c_char,
                        crate::src::utils::logtime(),
                        (*::std::mem::transmute::<&[u8; 14], &[libc::c_char; 14]>(
                            b"_check_header\x00",
                        ))
                        .as_ptr(),
                        165 as libc::c_int,
                    );
                }
                return;
            }
        }
    } else if loglevel as libc::c_uint >= crate::squeezelite_h::lWARN as libc::c_int as libc::c_uint
    {
        crate::src::utils::logprint(
            b"%s %s:%d unknown format - can\'t parse header\n\x00" as *const u8
                as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 14], &[libc::c_char; 14]>(b"_check_header\x00"))
                .as_ptr(),
            171 as libc::c_int,
        );
    };
}

unsafe extern "C" fn pcm_decode() -> crate::squeezelite_h::decode_state {
    let mut bytes: libc::c_uint = 0;
    let mut in_0: libc::c_uint = 0;
    let mut out: libc::c_uint = 0;
    let mut frames: crate::squeezelite_h::frames_t = 0;
    let mut count: crate::squeezelite_h::frames_t = 0;
    let mut optr = 0 as *mut crate::squeezelite_h::u32_t;
    let mut iptr = 0 as *mut crate::squeezelite_h::u8_t;
    let mut tmp: [crate::squeezelite_h::u8_t; 16] = [0; 16];
    crate::stdlib::pthread_mutex_lock(&mut (*streambuf).mutex);
    if decode.new_stream as libc::c_int != 0
        && (stream.state as libc::c_uint
            == crate::squeezelite_h::STREAMING_FILE as libc::c_int as libc::c_uint
            || pcm_check_header as libc::c_int != 0)
    {
        _check_header();
    }
    crate::stdlib::pthread_mutex_lock(&mut (*outputbuf).mutex);
    bytes = if crate::squeezelite_h::_buf_used(streambuf)
        < crate::src::buffer::_buf_cont_read(streambuf)
    {
        crate::squeezelite_h::_buf_used(streambuf)
    } else {
        crate::src::buffer::_buf_cont_read(streambuf)
    };
    out = (if crate::src::buffer::_buf_space(outputbuf)
        < crate::src::buffer::_buf_cont_write(outputbuf)
    {
        crate::src::buffer::_buf_space(outputbuf)
    } else {
        crate::src::buffer::_buf_cont_write(outputbuf)
    })
    .wrapping_div(8 as libc::c_int as libc::c_uint);
    if stream.state as libc::c_uint
        <= crate::squeezelite_h::DISCONNECT as libc::c_int as libc::c_uint
        && bytes == 0 as libc::c_int as libc::c_uint
        || limit as libc::c_int != 0 && audio_left == 0 as libc::c_int as libc::c_uint
    {
        crate::stdlib::pthread_mutex_unlock(&mut (*outputbuf).mutex);
        crate::stdlib::pthread_mutex_unlock(&mut (*streambuf).mutex);
        return crate::squeezelite_h::DECODE_COMPLETE;
    }
    if decode.new_stream {
        if loglevel as libc::c_uint >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint {
            crate::src::utils::logprint(
                b"%s %s:%d setting track_start\n\x00" as *const u8 as *const libc::c_char,
                crate::src::utils::logtime(),
                (*::std::mem::transmute::<&[u8; 11], &[libc::c_char; 11]>(b"pcm_decode\x00"))
                    .as_ptr(),
                206 as libc::c_int,
            );
        }
        output.track_start = (*outputbuf).writep;
        decode.new_stream = 0 as libc::c_int != 0;
        output.next_sample_rate =
            crate::src::decode::decode_newstream(sample_rate, output.supported_rates.as_mut_ptr());
        if output.fade_mode as u64 != 0 {
            crate::src::output::_checkfade(1 as libc::c_int != 0);
        }
        bytes_per_frame = channels.wrapping_mul(sample_size)
    }
    optr = (*outputbuf).writep as *mut crate::squeezelite_h::u32_t;
    iptr = (*streambuf).readp;
    in_0 = bytes.wrapping_div(bytes_per_frame);
    //  handle frame wrapping round end of streambuf
    //  - only need if resizing of streambuf does not avoid this, could occur in localfile case
    if in_0 == 0 as libc::c_int as libc::c_uint
        && bytes > 0 as libc::c_int as libc::c_uint
        && crate::squeezelite_h::_buf_used(streambuf) >= bytes_per_frame
    {
        crate::stdlib::memcpy(
            tmp.as_mut_ptr() as *mut libc::c_void,
            iptr as *const libc::c_void,
            bytes as libc::c_ulong,
        );
        crate::stdlib::memcpy(
            tmp.as_mut_ptr().offset(bytes as isize) as *mut libc::c_void,
            (*streambuf).buf as *const libc::c_void,
            bytes_per_frame.wrapping_sub(bytes) as libc::c_ulong,
        );
        iptr = tmp.as_mut_ptr();
        in_0 = 1 as libc::c_int as libc::c_uint
    }
    frames = if in_0 < out { in_0 } else { out };
    frames = if frames < 4096 as libc::c_int as libc::c_uint {
        frames
    } else {
        4096 as libc::c_int as libc::c_uint
    };
    if limit as libc::c_int != 0 && frames.wrapping_mul(bytes_per_frame) > audio_left {
        if loglevel as libc::c_uint >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint {
            crate::src::utils::logprint(
                b"%s %s:%d reached end of audio\n\x00" as *const u8 as *const libc::c_char,
                crate::src::utils::logtime(),
                (*::std::mem::transmute::<&[u8; 11], &[libc::c_char; 11]>(b"pcm_decode\x00"))
                    .as_ptr(),
                261 as libc::c_int,
            );
        }
        frames = audio_left.wrapping_div(bytes_per_frame)
    }
    count = frames.wrapping_mul(channels);
    if channels == 2 as libc::c_int as libc::c_uint {
        if sample_size == 1 as libc::c_int as libc::c_uint {
            loop {
                let fresh0 = count;
                count = count.wrapping_sub(1);
                if !(fresh0 != 0) {
                    break;
                }
                let fresh1 = iptr;
                iptr = iptr.offset(1);
                let fresh2 = optr;
                optr = optr.offset(1);
                *fresh2 =
                    ((*fresh1 as libc::c_int) << 24 as libc::c_int) as crate::squeezelite_h::u32_t
            }
        } else if sample_size == 2 as libc::c_int as libc::c_uint {
            if bigendian {
                loop {
                    let fresh3 = count;
                    count = count.wrapping_sub(1);
                    if !(fresh3 != 0) {
                        break;
                    }
                    let fresh4 = optr;
                    optr = optr.offset(1);
                    *fresh4 = ((*iptr as libc::c_int) << 24 as libc::c_int
                        | (*iptr.offset(1 as libc::c_int as isize) as libc::c_int)
                            << 16 as libc::c_int)
                        as crate::squeezelite_h::u32_t;
                    iptr = iptr.offset(2 as libc::c_int as isize)
                }
            } else {
                loop {
                    let fresh5 = count;
                    count = count.wrapping_sub(1);
                    if !(fresh5 != 0) {
                        break;
                    }
                    let fresh6 = optr;
                    optr = optr.offset(1);
                    *fresh6 = ((*iptr as libc::c_int) << 16 as libc::c_int
                        | (*iptr.offset(1 as libc::c_int as isize) as libc::c_int)
                            << 24 as libc::c_int)
                        as crate::squeezelite_h::u32_t;
                    iptr = iptr.offset(2 as libc::c_int as isize)
                }
            }
        } else if sample_size == 3 as libc::c_int as libc::c_uint {
            if bigendian {
                loop {
                    let fresh7 = count;
                    count = count.wrapping_sub(1);
                    if !(fresh7 != 0) {
                        break;
                    }
                    let fresh8 = optr;
                    optr = optr.offset(1);
                    *fresh8 = ((*iptr as libc::c_int) << 24 as libc::c_int
                        | (*iptr.offset(1 as libc::c_int as isize) as libc::c_int)
                            << 16 as libc::c_int
                        | (*iptr.offset(2 as libc::c_int as isize) as libc::c_int)
                            << 8 as libc::c_int)
                        as crate::squeezelite_h::u32_t;
                    iptr = iptr.offset(3 as libc::c_int as isize)
                }
            } else {
                loop {
                    let fresh9 = count;
                    count = count.wrapping_sub(1);
                    if !(fresh9 != 0) {
                        break;
                    }
                    let fresh10 = optr;
                    optr = optr.offset(1);
                    *fresh10 = ((*iptr as libc::c_int) << 8 as libc::c_int
                        | (*iptr.offset(1 as libc::c_int as isize) as libc::c_int)
                            << 16 as libc::c_int
                        | (*iptr.offset(2 as libc::c_int as isize) as libc::c_int)
                            << 24 as libc::c_int)
                        as crate::squeezelite_h::u32_t;
                    iptr = iptr.offset(3 as libc::c_int as isize)
                }
            }
        } else if sample_size == 4 as libc::c_int as libc::c_uint {
            if bigendian {
                loop {
                    let fresh11 = count;
                    count = count.wrapping_sub(1);
                    if !(fresh11 != 0) {
                        break;
                    }
                    let fresh12 = optr;
                    optr = optr.offset(1);
                    *fresh12 = ((*iptr as libc::c_int) << 24 as libc::c_int
                        | (*iptr.offset(1 as libc::c_int as isize) as libc::c_int)
                            << 16 as libc::c_int
                        | (*iptr.offset(2 as libc::c_int as isize) as libc::c_int)
                            << 8 as libc::c_int
                        | *iptr.offset(3 as libc::c_int as isize) as libc::c_int)
                        as crate::squeezelite_h::u32_t;
                    iptr = iptr.offset(4 as libc::c_int as isize)
                }
            } else {
                loop {
                    let fresh13 = count;
                    count = count.wrapping_sub(1);
                    if !(fresh13 != 0) {
                        break;
                    }
                    let fresh14 = optr;
                    optr = optr.offset(1);
                    *fresh14 = (*iptr as libc::c_int
                        | (*iptr.offset(1 as libc::c_int as isize) as libc::c_int)
                            << 8 as libc::c_int
                        | (*iptr.offset(2 as libc::c_int as isize) as libc::c_int)
                            << 16 as libc::c_int
                        | (*iptr.offset(3 as libc::c_int as isize) as libc::c_int)
                            << 24 as libc::c_int)
                        as crate::squeezelite_h::u32_t;
                    iptr = iptr.offset(4 as libc::c_int as isize)
                }
            }
        }
    } else if channels == 1 as libc::c_int as libc::c_uint {
        if sample_size == 1 as libc::c_int as libc::c_uint {
            loop {
                let fresh15 = count;
                count = count.wrapping_sub(1);
                if !(fresh15 != 0) {
                    break;
                }
                let fresh16 = iptr;
                iptr = iptr.offset(1);
                *optr =
                    ((*fresh16 as libc::c_int) << 24 as libc::c_int) as crate::squeezelite_h::u32_t;
                *optr.offset(1 as libc::c_int as isize) = *optr;
                optr = optr.offset(2 as libc::c_int as isize)
            }
        } else if sample_size == 2 as libc::c_int as libc::c_uint {
            if bigendian {
                loop {
                    let fresh17 = count;
                    count = count.wrapping_sub(1);
                    if !(fresh17 != 0) {
                        break;
                    }
                    *optr = ((*iptr as libc::c_int) << 24 as libc::c_int
                        | (*iptr.offset(1 as libc::c_int as isize) as libc::c_int)
                            << 16 as libc::c_int)
                        as crate::squeezelite_h::u32_t;
                    *optr.offset(1 as libc::c_int as isize) = *optr;
                    iptr = iptr.offset(2 as libc::c_int as isize);
                    optr = optr.offset(2 as libc::c_int as isize)
                }
            } else {
                loop {
                    let fresh18 = count;
                    count = count.wrapping_sub(1);
                    if !(fresh18 != 0) {
                        break;
                    }
                    *optr = ((*iptr as libc::c_int) << 16 as libc::c_int
                        | (*iptr.offset(1 as libc::c_int as isize) as libc::c_int)
                            << 24 as libc::c_int)
                        as crate::squeezelite_h::u32_t;
                    *optr.offset(1 as libc::c_int as isize) = *optr;
                    iptr = iptr.offset(2 as libc::c_int as isize);
                    optr = optr.offset(2 as libc::c_int as isize)
                }
            }
        } else if sample_size == 3 as libc::c_int as libc::c_uint {
            if bigendian {
                loop {
                    let fresh19 = count;
                    count = count.wrapping_sub(1);
                    if !(fresh19 != 0) {
                        break;
                    }
                    *optr = ((*iptr as libc::c_int) << 24 as libc::c_int
                        | (*iptr.offset(1 as libc::c_int as isize) as libc::c_int)
                            << 16 as libc::c_int
                        | (*iptr.offset(2 as libc::c_int as isize) as libc::c_int)
                            << 8 as libc::c_int)
                        as crate::squeezelite_h::u32_t;
                    *optr.offset(1 as libc::c_int as isize) = *optr;
                    iptr = iptr.offset(3 as libc::c_int as isize);
                    optr = optr.offset(2 as libc::c_int as isize)
                }
            } else {
                loop {
                    let fresh20 = count;
                    count = count.wrapping_sub(1);
                    if !(fresh20 != 0) {
                        break;
                    }
                    *optr = ((*iptr as libc::c_int) << 8 as libc::c_int
                        | (*iptr.offset(1 as libc::c_int as isize) as libc::c_int)
                            << 16 as libc::c_int
                        | (*iptr.offset(2 as libc::c_int as isize) as libc::c_int)
                            << 24 as libc::c_int)
                        as crate::squeezelite_h::u32_t;
                    *optr.offset(1 as libc::c_int as isize) = *optr;
                    iptr = iptr.offset(3 as libc::c_int as isize);
                    optr = optr.offset(2 as libc::c_int as isize)
                }
            }
        } else if sample_size == 4 as libc::c_int as libc::c_uint {
            if bigendian {
                loop {
                    let fresh21 = count;
                    count = count.wrapping_sub(1);
                    if !(fresh21 != 0) {
                        break;
                    }
                    let fresh22 = optr;
                    optr = optr.offset(1);
                    *fresh22 = ((*iptr as libc::c_int) << 24 as libc::c_int
                        | (*iptr.offset(1 as libc::c_int as isize) as libc::c_int)
                            << 16 as libc::c_int
                        | (*iptr.offset(2 as libc::c_int as isize) as libc::c_int)
                            << 8 as libc::c_int
                        | *iptr.offset(3 as libc::c_int as isize) as libc::c_int)
                        as crate::squeezelite_h::u32_t;
                    *optr.offset(1 as libc::c_int as isize) = *optr;
                    iptr = iptr.offset(4 as libc::c_int as isize);
                    optr = optr.offset(2 as libc::c_int as isize)
                }
            } else {
                loop {
                    let fresh23 = count;
                    count = count.wrapping_sub(1);
                    if !(fresh23 != 0) {
                        break;
                    }
                    let fresh24 = optr;
                    optr = optr.offset(1);
                    *fresh24 = (*iptr as libc::c_int
                        | (*iptr.offset(1 as libc::c_int as isize) as libc::c_int)
                            << 8 as libc::c_int
                        | (*iptr.offset(2 as libc::c_int as isize) as libc::c_int)
                            << 16 as libc::c_int
                        | (*iptr.offset(3 as libc::c_int as isize) as libc::c_int)
                            << 24 as libc::c_int)
                        as crate::squeezelite_h::u32_t;
                    *optr.offset(1 as libc::c_int as isize) = *optr;
                    iptr = iptr.offset(4 as libc::c_int as isize);
                    optr = optr.offset(2 as libc::c_int as isize)
                }
            }
        }
    } else {
        crate::src::utils::logprint(
            b"%s %s:%d unsupported channels\n\x00" as *const u8 as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 11], &[libc::c_char; 11]>(b"pcm_decode\x00")).as_ptr(),
            366 as libc::c_int,
        );
    }
    if loglevel as libc::c_uint >= crate::squeezelite_h::lSDEBUG as libc::c_int as libc::c_uint {
        crate::src::utils::logprint(
            b"%s %s:%d decoded %u frames\n\x00" as *const u8 as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 11], &[libc::c_char; 11]>(b"pcm_decode\x00")).as_ptr(),
            369 as libc::c_int,
            frames,
        );
    }
    crate::src::buffer::_buf_inc_readp(streambuf, frames.wrapping_mul(bytes_per_frame));
    if limit {
        audio_left = (audio_left as libc::c_uint).wrapping_sub(frames.wrapping_mul(bytes_per_frame))
            as crate::squeezelite_h::u32_t as crate::squeezelite_h::u32_t
    }
    crate::src::buffer::_buf_inc_writep(
        outputbuf,
        frames.wrapping_mul(8 as libc::c_int as libc::c_uint),
    );
    crate::stdlib::pthread_mutex_unlock(&mut (*outputbuf).mutex);
    crate::stdlib::pthread_mutex_unlock(&mut (*streambuf).mutex);
    return crate::squeezelite_h::DECODE_RUNNING;
}

unsafe extern "C" fn pcm_open(
    mut size: crate::squeezelite_h::u8_t,
    mut rate: crate::squeezelite_h::u8_t,
    mut chan: crate::squeezelite_h::u8_t,
    mut endianness: crate::squeezelite_h::u8_t,
) {
    sample_size =
        (size as libc::c_int - '0' as i32 + 1 as libc::c_int) as crate::squeezelite_h::u32_t;
    sample_rate = sample_rates[(rate as libc::c_int - '0' as i32) as usize];
    channels = (chan as libc::c_int - '0' as i32) as crate::squeezelite_h::u32_t;
    bigendian = endianness as libc::c_int == '0' as i32;
    limit = 0 as libc::c_int != 0;
    if loglevel as libc::c_uint >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint {
        crate::src::utils::logprint(
            b"%s %s:%d pcm size: %u rate: %u chan: %u bigendian: %u\n\x00" as *const u8
                as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 9], &[libc::c_char; 9]>(b"pcm_open\x00")).as_ptr(),
            397 as libc::c_int,
            sample_size,
            sample_rate,
            channels,
            bigendian as libc::c_int,
        );
    }
    crate::src::buffer::buf_adjust(
        streambuf,
        sample_size.wrapping_mul(channels) as crate::stddef_h::size_t,
    );
}

unsafe extern "C" fn pcm_close() {
    crate::src::buffer::buf_adjust(streambuf, 1 as libc::c_int as crate::stddef_h::size_t);
}
#[no_mangle]

pub unsafe extern "C" fn register_pcm() -> *mut crate::squeezelite_h::codec {
    if pcm_check_header {
        static mut ret: crate::squeezelite_h::codec = unsafe {
            {
                let mut init = crate::squeezelite_h::codec {
                    id: 'p' as i32 as libc::c_char,
                    types: b"wav,aif,pcm\x00" as *const u8 as *const libc::c_char
                        as *mut libc::c_char,
                    min_read_bytes: 4096 as libc::c_int as libc::c_uint,
                    min_space: 102400 as libc::c_int as libc::c_uint,
                    open: Some(
                        pcm_open
                            as unsafe extern "C" fn(
                                _: crate::squeezelite_h::u8_t,
                                _: crate::squeezelite_h::u8_t,
                                _: crate::squeezelite_h::u8_t,
                                _: crate::squeezelite_h::u8_t,
                            ) -> (),
                    ),
                    close: Some(pcm_close as unsafe extern "C" fn() -> ()),
                    decode: Some(
                        pcm_decode as unsafe extern "C" fn() -> crate::squeezelite_h::decode_state,
                    ),
                };
                init
            }
        };
        if loglevel as libc::c_uint >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint {
            crate::src::utils::logprint(
                b"%s %s:%d using pcm to decode wav,aif,pcm\n\x00" as *const u8
                    as *const libc::c_char,
                crate::src::utils::logtime(),
                (*::std::mem::transmute::<&[u8; 13], &[libc::c_char; 13]>(b"register_pcm\x00"))
                    .as_ptr(),
                418 as libc::c_int,
            );
        }
        return &mut ret;
    } else {
        static mut ret_0: crate::squeezelite_h::codec = unsafe {
            {
                let mut init = crate::squeezelite_h::codec {
                    id: 'p' as i32 as libc::c_char,
                    types: b"aif,pcm\x00" as *const u8 as *const libc::c_char as *mut libc::c_char,
                    min_read_bytes: 4096 as libc::c_int as libc::c_uint,
                    min_space: 102400 as libc::c_int as libc::c_uint,
                    open: Some(
                        pcm_open
                            as unsafe extern "C" fn(
                                _: crate::squeezelite_h::u8_t,
                                _: crate::squeezelite_h::u8_t,
                                _: crate::squeezelite_h::u8_t,
                                _: crate::squeezelite_h::u8_t,
                            ) -> (),
                    ),
                    close: Some(pcm_close as unsafe extern "C" fn() -> ()),
                    decode: Some(
                        pcm_decode as unsafe extern "C" fn() -> crate::squeezelite_h::decode_state,
                    ),
                };
                init
            }
        };
        if loglevel as libc::c_uint >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint {
            crate::src::utils::logprint(
                b"%s %s:%d using pcm to decode aif,pcm\n\x00" as *const u8 as *const libc::c_char,
                crate::src::utils::logtime(),
                (*::std::mem::transmute::<&[u8; 13], &[libc::c_char; 13]>(b"register_pcm\x00"))
                    .as_ptr(),
                433 as libc::c_int,
            );
        }
        return &mut ret_0;
    };
}
