// =============== BEGIN slimproto_h ================

// char header[] - added in sendRESP

// S:N:Slimproto _http_metadata_handler
#[repr(C, packed)]
#[derive(Copy, Clone)]
pub struct META_header {
    pub opcode: [libc::c_char; 4],
    pub length: crate::squeezelite_h::u32_t,
}
// S:N:Slimproto _http_response_handler

#[repr(C, packed)]
#[derive(Copy, Clone)]
pub struct RESP_header {
    pub opcode: [libc::c_char; 4],
    pub length: crate::squeezelite_h::u32_t,
}
//	u8_t capabilities[];
// S:N:Slimproto _stat_handler

#[repr(C, packed)]
#[derive(Copy, Clone)]
pub struct STAT_packet {
    pub opcode: [libc::c_char; 4],
    pub length: crate::squeezelite_h::u32_t,
    pub event: crate::squeezelite_h::u32_t,
    pub num_crlf: crate::squeezelite_h::u8_t,
    pub mas_initialized: crate::squeezelite_h::u8_t,
    pub mas_mode: crate::squeezelite_h::u8_t,
    pub stream_buffer_size: crate::squeezelite_h::u32_t,
    pub stream_buffer_fullness: crate::squeezelite_h::u32_t,
    pub bytes_received_H: crate::squeezelite_h::u32_t,
    pub bytes_received_L: crate::squeezelite_h::u32_t,
    pub signal_strength: crate::squeezelite_h::u16_t,
    pub jiffies: crate::squeezelite_h::u32_t,
    pub output_buffer_size: crate::squeezelite_h::u32_t,
    pub output_buffer_fullness: crate::squeezelite_h::u32_t,
    pub elapsed_seconds: crate::squeezelite_h::u32_t,
    pub voltage: crate::squeezelite_h::u16_t,
    pub elapsed_milliseconds: crate::squeezelite_h::u32_t,
    pub server_timestamp: crate::squeezelite_h::u32_t,
    pub error_code: crate::squeezelite_h::u16_t,
}
// S:N:Slimproto _disco_handler

#[repr(C, packed)]
#[derive(Copy, Clone)]
pub struct DSCO_packet {
    pub opcode: [libc::c_char; 4],
    pub length: crate::squeezelite_h::u32_t,
    pub reason: crate::squeezelite_h::u8_t,
}
// guids we don't use
// S:C:Commands

#[repr(C, packed)]
#[derive(Copy, Clone)]
pub struct serv_packet {
    pub opcode: [libc::c_char; 4],
    pub server_ip: crate::squeezelite_h::u32_t,
}
// possible sync group
// S:P:Squeezebox2

#[repr(C, packed)]
#[derive(Copy, Clone)]
pub struct setd_packet {
    pub opcode: [libc::c_char; 4],
    pub id: crate::squeezelite_h::u8_t,
    pub data: [libc::c_char; 0],
}
// char metadata[]
// S:N:Slimproto _http_setting_handler

#[repr(C, packed)]
#[derive(Copy, Clone)]
pub struct SETD_header {
    pub opcode: [libc::c_char; 4],
    pub length: crate::squeezelite_h::u32_t,
    pub id: crate::squeezelite_h::u8_t,
}
// S:P:Squeezebox2

#[repr(C, packed)]
#[derive(Copy, Clone)]
pub struct audg_packet {
    pub opcode: [libc::c_char; 4],
    pub old_gainL: crate::squeezelite_h::u32_t,
    pub old_gainR: crate::squeezelite_h::u32_t,
    pub adjust: crate::squeezelite_h::u8_t,
    pub preamp: crate::squeezelite_h::u8_t,
    pub gainL: crate::squeezelite_h::u32_t,
    pub gainR: crate::squeezelite_h::u32_t,
}
//char request_string[];
// S:P:Squeezebox2

#[repr(C, packed)]
#[derive(Copy, Clone)]
pub struct aude_packet {
    pub opcode: [libc::c_char; 4],
    pub enable_spdif: crate::squeezelite_h::u8_t,
    pub enable_dac: crate::squeezelite_h::u8_t,
}
// codec open - this is an extension to slimproto to allow the server to read the header and then return decode params

#[repr(C, packed)]
#[derive(Copy, Clone)]
pub struct codc_packet {
    pub opcode: [libc::c_char; 4],
    pub format: crate::squeezelite_h::u8_t,
    pub pcm_sample_size: crate::squeezelite_h::u8_t,
    pub pcm_sample_rate: crate::squeezelite_h::u8_t,
    pub pcm_channels: crate::squeezelite_h::u8_t,
    pub pcm_endianness: crate::squeezelite_h::u8_t,
}
// squence ids - unused
// S:P:Squeezebox2

#[repr(C, packed)]
#[derive(Copy, Clone)]
pub struct cont_packet {
    pub opcode: [libc::c_char; 4],
    pub metaint: crate::squeezelite_h::u32_t,
    pub loop_0: crate::squeezelite_h::u8_t,
}
// data
// from S:P:Squeezebox stream_s

#[repr(C, packed)]
#[derive(Copy, Clone)]
pub struct strm_packet {
    pub opcode: [libc::c_char; 4],
    pub command: libc::c_char,
    pub autostart: crate::squeezelite_h::u8_t,
    pub format: crate::squeezelite_h::u8_t,
    pub pcm_sample_size: crate::squeezelite_h::u8_t,
    pub pcm_sample_rate: crate::squeezelite_h::u8_t,
    pub pcm_channels: crate::squeezelite_h::u8_t,
    pub pcm_endianness: crate::squeezelite_h::u8_t,
    pub threshold: crate::squeezelite_h::u8_t,
    pub spdif_enable: crate::squeezelite_h::u8_t,
    pub transition_period: crate::squeezelite_h::u8_t,
    pub transition_type: crate::squeezelite_h::u8_t,
    pub flags: crate::squeezelite_h::u8_t,
    pub output_threshold: crate::squeezelite_h::u8_t,
    pub slaves: crate::squeezelite_h::u8_t,
    pub replay_gain: crate::squeezelite_h::u32_t,
    pub server_port: crate::squeezelite_h::u16_t,
    pub server_ip: crate::squeezelite_h::u32_t,
}
/*
 *  Squeezelite - lightweight headless squeezebox emulator
 *
 *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
 *      Ralph Irving 2015-2017, ralph_irving@hotmail.com
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
// packet formats for slimproto
// from S:N:Slimproto _hello_handler

#[repr(C, packed)]
#[derive(Copy, Clone)]
pub struct HELO_packet {
    pub opcode: [libc::c_char; 4],
    pub length: crate::squeezelite_h::u32_t,
    pub deviceid: crate::squeezelite_h::u8_t,
    pub revision: crate::squeezelite_h::u8_t,
    pub mac: [crate::squeezelite_h::u8_t; 6],
    pub uuid: [crate::squeezelite_h::u8_t; 16],
    pub wlan_channellist: crate::squeezelite_h::u16_t,
    pub bytes_received_H: crate::squeezelite_h::u32_t,
    pub bytes_received_L: crate::squeezelite_h::u32_t,
    pub lang: [libc::c_char; 2],
}
use ::libc;

pub use crate::stddef_h::size_t;

pub use crate::stdlib::_IO_codecvt;
pub use crate::stdlib::_IO_lock_t;
pub use crate::stdlib::_IO_marker;
pub use crate::stdlib::_IO_wide_data;
pub use crate::stdlib::__int32_t;
pub use crate::stdlib::__off64_t;
pub use crate::stdlib::__off_t;
pub use crate::stdlib::__socklen_t;
pub use crate::stdlib::__ssize_t;
pub use crate::stdlib::__uint16_t;
pub use crate::stdlib::__uint32_t;
pub use crate::stdlib::__uint64_t;
pub use crate::stdlib::__uint8_t;
pub use crate::stdlib::__useconds_t;
pub use crate::stdlib::fclose;
pub use crate::stdlib::fgets;
pub use crate::stdlib::fopen;
pub use crate::stdlib::fputs;
pub use crate::stdlib::int32_t;
pub use crate::stdlib::snprintf;
pub use crate::stdlib::ssize_t;
pub use crate::stdlib::FILE;
pub use crate::stdlib::_IO_FILE;

pub use crate::stdlib::__pthread_internal_list;
pub use crate::stdlib::__pthread_list_t;
pub use crate::stdlib::__pthread_mutex_s;
pub use crate::stdlib::pthread_mutex_t;
pub use crate::stdlib::u_int16_t;
pub use crate::stdlib::u_int32_t;
pub use crate::stdlib::u_int64_t;
pub use crate::stdlib::u_int8_t;

pub use crate::stdlib::__socket_type;
pub use crate::stdlib::close;
pub use crate::stdlib::sa_family_t;
pub use crate::stdlib::sleep;
pub use crate::stdlib::socklen_t;
pub use crate::stdlib::uint16_t;
pub use crate::stdlib::uint32_t;
pub use crate::stdlib::uint64_t;
pub use crate::stdlib::usleep;
pub use crate::stdlib::SOCK_CLOEXEC;
pub use crate::stdlib::SOCK_DCCP;
pub use crate::stdlib::SOCK_DGRAM;
pub use crate::stdlib::SOCK_NONBLOCK;
pub use crate::stdlib::SOCK_PACKET;
pub use crate::stdlib::SOCK_RAW;
pub use crate::stdlib::SOCK_RDM;
pub use crate::stdlib::SOCK_SEQPACKET;
pub use crate::stdlib::SOCK_STREAM;

pub use crate::squeezelite_h::_buf_used;
pub use crate::squeezelite_h::buffer;
pub use crate::squeezelite_h::codec;
pub use crate::squeezelite_h::decode_state;
pub use crate::squeezelite_h::decodestate;
pub use crate::squeezelite_h::disconnect_code;
pub use crate::squeezelite_h::event_type;
pub use crate::squeezelite_h::fade_dir;
pub use crate::squeezelite_h::fade_mode;
pub use crate::squeezelite_h::fade_state;
pub use crate::squeezelite_h::frames_t;
pub use crate::squeezelite_h::lDEBUG;
pub use crate::squeezelite_h::lERROR;
pub use crate::squeezelite_h::lINFO;
pub use crate::squeezelite_h::lSDEBUG;
pub use crate::squeezelite_h::lWARN;
pub use crate::squeezelite_h::log_level;
pub use crate::squeezelite_h::output_format;
pub use crate::squeezelite_h::output_state;
pub use crate::squeezelite_h::outputstate;
pub use crate::squeezelite_h::s32_t;
pub use crate::squeezelite_h::sockfd;
pub use crate::squeezelite_h::stream_state;
pub use crate::squeezelite_h::streamstate;
pub use crate::squeezelite_h::u16_t;
pub use crate::squeezelite_h::u32_t;
pub use crate::squeezelite_h::u64_t;
pub use crate::squeezelite_h::u8_t;
pub use crate::squeezelite_h::C2RustUnnamed_1;
pub use crate::squeezelite_h::DECODE_COMPLETE;
pub use crate::squeezelite_h::DECODE_ERROR;
pub use crate::squeezelite_h::DECODE_READY;
pub use crate::squeezelite_h::DECODE_RUNNING;
pub use crate::squeezelite_h::DECODE_STOPPED;
pub use crate::squeezelite_h::DISCONNECT;
pub use crate::squeezelite_h::DISCONNECT_OK;
pub use crate::squeezelite_h::EVENT_READ;
pub use crate::squeezelite_h::EVENT_TIMEOUT;
pub use crate::squeezelite_h::EVENT_WAKE;
pub use crate::squeezelite_h::FADE_ACTIVE;
pub use crate::squeezelite_h::FADE_CROSS;
pub use crate::squeezelite_h::FADE_CROSSFADE;
pub use crate::squeezelite_h::FADE_DOWN;
pub use crate::squeezelite_h::FADE_DUE;
pub use crate::squeezelite_h::FADE_IN;
pub use crate::squeezelite_h::FADE_INACTIVE;
pub use crate::squeezelite_h::FADE_INOUT;
pub use crate::squeezelite_h::FADE_NONE;
pub use crate::squeezelite_h::FADE_OUT;
pub use crate::squeezelite_h::FADE_UP;
pub use crate::squeezelite_h::LOCAL_DISCONNECT;
pub use crate::squeezelite_h::OUTPUT_BUFFER;
pub use crate::squeezelite_h::OUTPUT_OFF;
pub use crate::squeezelite_h::OUTPUT_PAUSE_FRAMES;
pub use crate::squeezelite_h::OUTPUT_RUNNING;
pub use crate::squeezelite_h::OUTPUT_SKIP_FRAMES;
pub use crate::squeezelite_h::OUTPUT_START_AT;
pub use crate::squeezelite_h::OUTPUT_STOPPED;
pub use crate::squeezelite_h::RECV_HEADERS;
pub use crate::squeezelite_h::REMOTE_DISCONNECT;
pub use crate::squeezelite_h::S16_LE;
pub use crate::squeezelite_h::S24_3LE;
pub use crate::squeezelite_h::S24_LE;
pub use crate::squeezelite_h::S32_LE;
pub use crate::squeezelite_h::SEND_HEADERS;
pub use crate::squeezelite_h::STOPPED;
pub use crate::squeezelite_h::STREAMING_BUFFERING;
pub use crate::squeezelite_h::STREAMING_FILE;
pub use crate::squeezelite_h::STREAMING_HTTP;
pub use crate::squeezelite_h::STREAMING_WAIT;
pub use crate::squeezelite_h::TIMEOUT;
pub use crate::squeezelite_h::UNREACHABLE;
pub use crate::src::buffer::buf_flush;
pub use crate::src::decode::codec_open;
pub use crate::src::decode::decode_flush;
pub use crate::src::output::output_flush;
pub use crate::src::output_alsa::set_volume;
pub use crate::src::stream::stream_disconnect;
pub use crate::src::stream::stream_file;
pub use crate::src::stream::stream_sock;
pub use crate::src::utils::connect_timeout;
pub use crate::src::utils::gettime_ms;
pub use crate::src::utils::logprint;
pub use crate::src::utils::logtime;
pub use crate::src::utils::packN;
pub use crate::src::utils::packn;
pub use crate::src::utils::server_addr;
pub use crate::src::utils::set_nonblock;
pub use crate::src::utils::set_readwake_handles;
pub use crate::src::utils::unpackN;
pub use crate::src::utils::wait_readwake;
use crate::stdlib::__errno_location;
pub use crate::stdlib::eventfd;
pub use crate::stdlib::eventfd_t;
pub use crate::stdlib::eventfd_write;
use crate::stdlib::free;
use crate::stdlib::getsockname;
pub use crate::stdlib::htonl;
pub use crate::stdlib::htons;
pub use crate::stdlib::in_addr;
pub use crate::stdlib::in_addr_t;
pub use crate::stdlib::in_port_t;
use crate::stdlib::inet_ntoa;
use crate::stdlib::malloc;
use crate::stdlib::memcpy;
use crate::stdlib::memset;
pub use crate::stdlib::nfds_t;
pub use crate::stdlib::ntohs;
pub use crate::stdlib::poll;
pub use crate::stdlib::pollfd;
use crate::stdlib::pthread_mutex_lock;
use crate::stdlib::pthread_mutex_unlock;
use crate::stdlib::recv;
use crate::stdlib::recvfrom;
use crate::stdlib::send;
use crate::stdlib::sendto;
use crate::stdlib::setsockopt;
pub use crate::stdlib::sockaddr;
pub use crate::stdlib::sockaddr_in;
use crate::stdlib::socket;
use crate::stdlib::strcat;
use crate::stdlib::strerror;
use crate::stdlib::strlen;
use crate::stdlib::strncat;
use crate::stdlib::strncmp;
use crate::stdlib::strncpy;
pub use crate::stdlib::C2RustUnnamed_0;
pub use crate::stdlib::MSG_BATCH;
pub use crate::stdlib::MSG_CMSG_CLOEXEC;
pub use crate::stdlib::MSG_CONFIRM;
pub use crate::stdlib::MSG_CTRUNC;
pub use crate::stdlib::MSG_DONTROUTE;
pub use crate::stdlib::MSG_DONTWAIT;
pub use crate::stdlib::MSG_EOR;
pub use crate::stdlib::MSG_ERRQUEUE;
pub use crate::stdlib::MSG_FASTOPEN;
pub use crate::stdlib::MSG_FIN;
pub use crate::stdlib::MSG_MORE;
pub use crate::stdlib::MSG_NOSIGNAL;
pub use crate::stdlib::MSG_OOB;
pub use crate::stdlib::MSG_PEEK;
pub use crate::stdlib::MSG_PROXY;
pub use crate::stdlib::MSG_RST;
pub use crate::stdlib::MSG_SYN;
pub use crate::stdlib::MSG_TRUNC;
pub use crate::stdlib::MSG_WAITALL;
pub use crate::stdlib::MSG_WAITFORONE;
pub use crate::stdlib::MSG_ZEROCOPY;
extern "C" {
    #[no_mangle]
    pub static mut streambuf: *mut crate::squeezelite_h::buffer;
    #[no_mangle]
    pub static mut outputbuf: *mut crate::squeezelite_h::buffer;
    #[no_mangle]
    pub static mut stream: crate::squeezelite_h::streamstate;
    #[no_mangle]
    pub static mut output: crate::squeezelite_h::outputstate;
    #[no_mangle]
    pub static mut decode: crate::squeezelite_h::decodestate;
    #[no_mangle]
    pub static mut codecs: [*mut crate::squeezelite_h::codec; 0];
}

#[repr(C)]
#[derive(Copy, Clone)]
pub struct C2RustUnnamed_17 {
    pub updated: crate::squeezelite_h::u32_t,
    pub stream_start: crate::squeezelite_h::u32_t,
    pub stream_full: crate::squeezelite_h::u32_t,
    pub stream_size: crate::squeezelite_h::u32_t,
    pub stream_bytes: crate::squeezelite_h::u64_t,
    pub output_full: crate::squeezelite_h::u32_t,
    pub output_size: crate::squeezelite_h::u32_t,
    pub frames_played: crate::squeezelite_h::u32_t,
    pub device_frames: crate::squeezelite_h::u32_t,
    pub current_sample_rate: crate::squeezelite_h::u32_t,
    pub last: crate::squeezelite_h::u32_t,
    pub stream_state: crate::squeezelite_h::stream_state,
}

#[repr(C)]
#[derive(Copy, Clone)]
pub struct handler {
    pub opcode: [libc::c_char; 5],
    pub handler:
        Option<unsafe extern "C" fn(_: *mut crate::squeezelite_h::u8_t, _: libc::c_int) -> ()>,
}
/*
 *  Squeezelite - lightweight headless squeezebox emulator
 *
 *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
 *      Ralph Irving 2015-2017, ralph_irving@hotmail.com
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additions (c) Paul Hermann, 2015-2017 under the same license terms
 *   -Control of Raspberry pi GPIO for amplifier power
 *   -Launch script on power status change from LMS
 */

static mut loglevel: crate::squeezelite_h::log_level = crate::squeezelite_h::lERROR;
// 3483

static mut sock: crate::squeezelite_h::sockfd = -(1 as libc::c_int);

static mut slimproto_ip: crate::stdlib::in_addr_t = 0 as libc::c_int as crate::stdlib::in_addr_t;
#[no_mangle]

pub static mut wake_e: libc::c_int = 0;

static mut status: C2RustUnnamed_17 = C2RustUnnamed_17 {
    updated: 0,
    stream_start: 0,
    stream_full: 0,
    stream_size: 0,
    stream_bytes: 0,
    output_full: 0,
    output_size: 0,
    frames_played: 0,
    device_frames: 0,
    current_sample_rate: 0,
    last: 0,
    stream_state: crate::squeezelite_h::STOPPED,
};
#[no_mangle]

pub static mut autostart: libc::c_int = 0;
#[no_mangle]

pub static mut sentSTMu: bool = false;
#[no_mangle]

pub static mut sentSTMo: bool = false;
#[no_mangle]

pub static mut sentSTMl: bool = false;
#[no_mangle]

pub static mut new_server: crate::squeezelite_h::u32_t = 0;
#[no_mangle]

pub static mut new_server_cap: *mut libc::c_char = 0 as *const libc::c_char as *mut libc::c_char;
#[no_mangle]

pub static mut player_name: [libc::c_char; 65] = [
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0,
];
#[no_mangle]

pub static mut name_file: *const libc::c_char = 0 as *const libc::c_char;
#[no_mangle]

pub unsafe extern "C" fn send_packet(
    mut packet: *mut crate::squeezelite_h::u8_t,
    mut len: crate::stddef_h::size_t,
) {
    let mut ptr = packet; // squeezeplay
    let mut try_0 = 0 as libc::c_int as libc::c_uint;
    let mut n: crate::stdlib::ssize_t = 0;
    while len != 0 {
        n = crate::stdlib::send(
            sock,
            ptr as *const libc::c_void,
            len,
            crate::stdlib::MSG_NOSIGNAL as libc::c_int,
        );
        if n <= 0 as libc::c_int as libc::c_long {
            if n < 0 as libc::c_int as libc::c_long
                && *crate::stdlib::__errno_location() == 11 as libc::c_int
                && try_0 < 10 as libc::c_int as libc::c_uint
            {
                if loglevel as libc::c_uint
                    >= crate::squeezelite_h::lDEBUG as libc::c_int as libc::c_uint
                {
                    try_0 = try_0.wrapping_add(1);
                    crate::src::utils::logprint(
                        b"%s %s:%d retrying (%d) writing to socket\n\x00" as *const u8
                            as *const libc::c_char,
                        crate::src::utils::logtime(),
                        (*::std::mem::transmute::<&[u8; 12], &[libc::c_char; 12]>(
                            b"send_packet\x00",
                        ))
                        .as_ptr(),
                        104 as libc::c_int,
                        try_0,
                    );
                }
                crate::stdlib::usleep(1000 as libc::c_int as crate::stdlib::__useconds_t);
            } else {
                if loglevel as libc::c_uint
                    >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint
                {
                    crate::src::utils::logprint(
                        b"%s %s:%d failed writing to socket: %s\n\x00" as *const u8
                            as *const libc::c_char,
                        crate::src::utils::logtime(),
                        (*::std::mem::transmute::<&[u8; 12], &[libc::c_char; 12]>(
                            b"send_packet\x00",
                        ))
                        .as_ptr(),
                        108 as libc::c_int,
                        crate::stdlib::strerror(*crate::stdlib::__errno_location()),
                    );
                }
                return;
            }
        } else {
            ptr = ptr.offset(n as isize);
            len = (len as libc::c_ulong).wrapping_sub(n as libc::c_ulong) as crate::stddef_h::size_t
                as crate::stddef_h::size_t
        }
    }
}

unsafe extern "C" fn sendHELO(
    mut reconnect: bool,
    mut fixed_cap: *const libc::c_char,
    mut var_cap: *const libc::c_char,
    mut mac: *mut crate::squeezelite_h::u8_t,
) {
    let mut base_cap = 0 as *const libc::c_char;
    let mut pkt = crate::src::slimproto::HELO_packet {
        opcode: [0; 4],
        length: 0,
        deviceid: 0,
        revision: 0,
        mac: [0; 6],
        uuid: [0; 16],
        wlan_channellist: 0,
        bytes_received_H: 0,
        bytes_received_L: 0,
        lang: [0; 2],
    };
    base_cap =
        b"Model=squeezelite,AccuratePlayPoints=1,HasDigitalOut=1,HasPolarityInversion=1,Firmware=v1.9.7-1218\x00"
            as *const u8 as *const libc::c_char;
    crate::stdlib::memset(
        &mut pkt as *mut crate::src::slimproto::HELO_packet as *mut libc::c_void,
        0 as libc::c_int,
        ::std::mem::size_of::<crate::src::slimproto::HELO_packet>() as libc::c_ulong,
    );
    crate::stdlib::memcpy(
        &mut pkt.opcode as *mut [libc::c_char; 4] as *mut libc::c_void,
        b"HELO\x00" as *const u8 as *const libc::c_char as *const libc::c_void,
        4 as libc::c_int as libc::c_ulong,
    );
    pkt.length = crate::stdlib::htonl(
        (::std::mem::size_of::<crate::src::slimproto::HELO_packet>() as libc::c_ulong)
            .wrapping_sub(8 as libc::c_int as libc::c_ulong)
            .wrapping_add(crate::stdlib::strlen(base_cap))
            .wrapping_add(crate::stdlib::strlen(fixed_cap))
            .wrapping_add(crate::stdlib::strlen(var_cap)) as crate::stdlib::uint32_t,
    );
    pkt.deviceid = 12 as libc::c_int as crate::squeezelite_h::u8_t;
    pkt.revision = 0 as libc::c_int as crate::squeezelite_h::u8_t;
    crate::src::utils::packn(
        &mut pkt.wlan_channellist,
        if reconnect as libc::c_int != 0 {
            0x4000 as libc::c_int
        } else {
            0 as libc::c_int
        } as crate::squeezelite_h::u16_t,
    );
    crate::src::utils::packN(
        &mut pkt.bytes_received_H,
        (status.stream_bytes >> 32 as libc::c_int) as crate::squeezelite_h::u32_t,
    );
    crate::src::utils::packN(
        &mut pkt.bytes_received_L,
        (status.stream_bytes & 0xffffffff as libc::c_uint as libc::c_ulong)
            as crate::squeezelite_h::u32_t,
    );
    crate::stdlib::memcpy(
        pkt.mac.as_mut_ptr() as *mut libc::c_void,
        mac as *const libc::c_void,
        6 as libc::c_int as libc::c_ulong,
    );
    if loglevel as libc::c_uint >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint {
        crate::src::utils::logprint(
            b"%s %s:%d mac: %02x:%02x:%02x:%02x:%02x:%02x\n\x00" as *const u8
                as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 9], &[libc::c_char; 9]>(b"sendHELO\x00")).as_ptr(),
            142 as libc::c_int,
            pkt.mac[0 as libc::c_int as usize] as libc::c_int,
            pkt.mac[1 as libc::c_int as usize] as libc::c_int,
            pkt.mac[2 as libc::c_int as usize] as libc::c_int,
            pkt.mac[3 as libc::c_int as usize] as libc::c_int,
            pkt.mac[4 as libc::c_int as usize] as libc::c_int,
            pkt.mac[5 as libc::c_int as usize] as libc::c_int,
        );
    }
    if loglevel as libc::c_uint >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint {
        crate::src::utils::logprint(
            b"%s %s:%d cap: %s%s%s\n\x00" as *const u8 as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 9], &[libc::c_char; 9]>(b"sendHELO\x00")).as_ptr(),
            144 as libc::c_int,
            base_cap,
            fixed_cap,
            var_cap,
        );
    }
    send_packet(
        &mut pkt as *mut crate::src::slimproto::HELO_packet as *mut crate::squeezelite_h::u8_t,
        ::std::mem::size_of::<crate::src::slimproto::HELO_packet>() as libc::c_ulong,
    );
    send_packet(
        base_cap as *mut crate::squeezelite_h::u8_t,
        crate::stdlib::strlen(base_cap),
    );
    send_packet(
        fixed_cap as *mut crate::squeezelite_h::u8_t,
        crate::stdlib::strlen(fixed_cap),
    );
    send_packet(
        var_cap as *mut crate::squeezelite_h::u8_t,
        crate::stdlib::strlen(var_cap),
    );
}

unsafe extern "C" fn sendSTAT(
    mut event: *const libc::c_char,
    mut server_timestamp: crate::squeezelite_h::u32_t,
) {
    let mut pkt = crate::src::slimproto::STAT_packet {
        opcode: [0; 4],
        length: 0,
        event: 0,
        num_crlf: 0,
        mas_initialized: 0,
        mas_mode: 0,
        stream_buffer_size: 0,
        stream_buffer_fullness: 0,
        bytes_received_H: 0,
        bytes_received_L: 0,
        signal_strength: 0,
        jiffies: 0,
        output_buffer_size: 0,
        output_buffer_fullness: 0,
        elapsed_seconds: 0,
        voltage: 0,
        elapsed_milliseconds: 0,
        server_timestamp: 0,
        error_code: 0,
    };
    let mut now = crate::src::utils::gettime_ms();
    let mut ms_played: crate::squeezelite_h::u32_t = 0;
    if status.current_sample_rate != 0
        && status.frames_played != 0
        && status.frames_played > status.device_frames
    {
        ms_played = (status.frames_played.wrapping_sub(status.device_frames)
            as crate::squeezelite_h::u64_t)
            .wrapping_mul(1000 as libc::c_int as crate::squeezelite_h::u64_t)
            .wrapping_div(status.current_sample_rate as crate::squeezelite_h::u64_t)
            as crate::squeezelite_h::u32_t;
        if now > status.updated {
            ms_played = (ms_played as libc::c_uint).wrapping_add(now.wrapping_sub(status.updated))
                as crate::squeezelite_h::u32_t
                as crate::squeezelite_h::u32_t
        }
        if loglevel as libc::c_uint >= crate::squeezelite_h::lSDEBUG as libc::c_int as libc::c_uint
        {
            crate::src::utils::logprint(
                b"%s %s:%d ms_played: %u (frames_played: %u device_frames: %u)\n\x00" as *const u8
                    as *const libc::c_char,
                crate::src::utils::logtime(),
                (*::std::mem::transmute::<&[u8; 9], &[libc::c_char; 9]>(b"sendSTAT\x00")).as_ptr(),
                160 as libc::c_int,
                ms_played,
                status.frames_played,
                status.device_frames,
            );
        }
    } else if status.frames_played != 0 && now > status.stream_start {
        ms_played = now.wrapping_sub(status.stream_start);
        if loglevel as libc::c_uint >= crate::squeezelite_h::lSDEBUG as libc::c_int as libc::c_uint
        {
            crate::src::utils::logprint(b"%s %s:%d ms_played: %u using elapsed time (frames_played: %u device_frames: %u)\n\x00"
                         as *const u8 as *const libc::c_char, crate::src::utils::logtime(),
                     (*::std::mem::transmute::<&[u8; 9],
                                               &[libc::c_char; 9]>(b"sendSTAT\x00")).as_ptr(),
                     163 as libc::c_int, ms_played, status.frames_played,
                     status.device_frames);
        }
    } else {
        if loglevel as libc::c_uint >= crate::squeezelite_h::lSDEBUG as libc::c_int as libc::c_uint
        {
            crate::src::utils::logprint(
                b"%s %s:%d ms_played: 0\n\x00" as *const u8 as *const libc::c_char,
                crate::src::utils::logtime(),
                (*::std::mem::transmute::<&[u8; 9], &[libc::c_char; 9]>(b"sendSTAT\x00")).as_ptr(),
                165 as libc::c_int,
            );
        }
        ms_played = 0 as libc::c_int as crate::squeezelite_h::u32_t
    }
    crate::stdlib::memset(
        &mut pkt as *mut crate::src::slimproto::STAT_packet as *mut libc::c_void,
        0 as libc::c_int,
        ::std::mem::size_of::<crate::src::slimproto::STAT_packet>() as libc::c_ulong,
    );
    crate::stdlib::memcpy(
        &mut pkt.opcode as *mut [libc::c_char; 4] as *mut libc::c_void,
        b"STAT\x00" as *const u8 as *const libc::c_char as *const libc::c_void,
        4 as libc::c_int as libc::c_ulong,
    );
    pkt.length = crate::stdlib::htonl(
        (::std::mem::size_of::<crate::src::slimproto::STAT_packet>() as libc::c_ulong)
            .wrapping_sub(8 as libc::c_int as libc::c_ulong) as crate::stdlib::uint32_t,
    );
    crate::stdlib::memcpy(
        &mut pkt.event as *mut crate::squeezelite_h::u32_t as *mut libc::c_void,
        event as *const libc::c_void,
        4 as libc::c_int as libc::c_ulong,
    );
    // num_crlf
    // mas_initialized; mas_mode;
    crate::src::utils::packN(&mut pkt.stream_buffer_fullness, status.stream_full);
    crate::src::utils::packN(&mut pkt.stream_buffer_size, status.stream_size);
    crate::src::utils::packN(
        &mut pkt.bytes_received_H,
        (status.stream_bytes >> 32 as libc::c_int) as crate::squeezelite_h::u32_t,
    );
    crate::src::utils::packN(
        &mut pkt.bytes_received_L,
        (status.stream_bytes & 0xffffffff as libc::c_uint as libc::c_ulong)
            as crate::squeezelite_h::u32_t,
    );
    pkt.signal_strength = 0xffff as libc::c_int as crate::squeezelite_h::u16_t;
    crate::src::utils::packN(&mut pkt.jiffies, now);
    crate::src::utils::packN(&mut pkt.output_buffer_size, status.output_size);
    crate::src::utils::packN(&mut pkt.output_buffer_fullness, status.output_full);
    crate::src::utils::packN(
        &mut pkt.elapsed_seconds,
        ms_played.wrapping_div(1000 as libc::c_int as libc::c_uint),
    );
    // voltage;
    crate::src::utils::packN(&mut pkt.elapsed_milliseconds, ms_played); // keep this is server format - don't unpack/pack
    pkt.server_timestamp = server_timestamp;
    // error_code;
    if loglevel as libc::c_uint >= crate::squeezelite_h::lDEBUG as libc::c_int as libc::c_uint {
        crate::src::utils::logprint(
            b"%s %s:%d STAT: %s\n\x00" as *const u8 as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 9], &[libc::c_char; 9]>(b"sendSTAT\x00")).as_ptr(),
            189 as libc::c_int,
            event,
        ); // id 0 is playername S:P:Squeezebox2
    } // STMt replay_gain is no longer used to track latency, but support it
    if loglevel as libc::c_uint == crate::squeezelite_h::lSDEBUG as libc::c_int as libc::c_uint {
        if loglevel as libc::c_uint >= crate::squeezelite_h::lSDEBUG as libc::c_int as libc::c_uint
        {
            crate::src::utils::logprint(b"%s %s:%d received bytesL: %u streambuf: %u outputbuf: %u calc elapsed: %u real elapsed: %u (diff: %d) device: %u delay: %d\n\x00"
                         as *const u8 as *const libc::c_char, crate::src::utils::logtime(),
                     (*::std::mem::transmute::<&[u8; 9],
                                               &[libc::c_char; 9]>(b"sendSTAT\x00")).as_ptr(),
                     194 as libc::c_int, status.stream_bytes as crate::squeezelite_h::u32_t,
                     status.stream_full, status.output_full, ms_played,
                     now.wrapping_sub(status.stream_start),
                     ms_played.wrapping_sub(now).wrapping_add(status.stream_start),
                     status.device_frames.wrapping_mul(1000 as libc::c_int as
                                                           libc::c_uint).wrapping_div(status.current_sample_rate),
                     now.wrapping_sub(status.updated)); // keep in network byte order
        }
    } // keep in network byte order
    send_packet(
        &mut pkt as *mut crate::src::slimproto::STAT_packet as *mut crate::squeezelite_h::u8_t,
        ::std::mem::size_of::<crate::src::slimproto::STAT_packet>() as libc::c_ulong,
    );
}

unsafe extern "C" fn sendDSCO(mut disconnect: crate::squeezelite_h::disconnect_code) {
    let mut pkt = crate::src::slimproto::DSCO_packet {
        opcode: [0; 4],
        length: 0,
        reason: 0,
    };
    crate::stdlib::memset(
        &mut pkt as *mut crate::src::slimproto::DSCO_packet as *mut libc::c_void,
        0 as libc::c_int,
        ::std::mem::size_of::<crate::src::slimproto::DSCO_packet>() as libc::c_ulong,
    );
    crate::stdlib::memcpy(
        &mut pkt.opcode as *mut [libc::c_char; 4] as *mut libc::c_void,
        b"DSCO\x00" as *const u8 as *const libc::c_char as *const libc::c_void,
        4 as libc::c_int as libc::c_ulong,
    );
    pkt.length = crate::stdlib::htonl(
        (::std::mem::size_of::<crate::src::slimproto::DSCO_packet>() as libc::c_ulong)
            .wrapping_sub(8 as libc::c_int as libc::c_ulong) as crate::stdlib::uint32_t,
    );
    pkt.reason = (disconnect as libc::c_uint & 0xff as libc::c_int as libc::c_uint)
        as crate::squeezelite_h::u8_t;
    if loglevel as libc::c_uint >= crate::squeezelite_h::lDEBUG as libc::c_int as libc::c_uint {
        crate::src::utils::logprint(
            b"%s %s:%d DSCO: %d\n\x00" as *const u8 as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 9], &[libc::c_char; 9]>(b"sendDSCO\x00")).as_ptr(),
            208 as libc::c_int,
            disconnect as libc::c_uint,
        );
    }
    send_packet(
        &mut pkt as *mut crate::src::slimproto::DSCO_packet as *mut crate::squeezelite_h::u8_t,
        ::std::mem::size_of::<crate::src::slimproto::DSCO_packet>() as libc::c_ulong,
    );
}

unsafe extern "C" fn sendRESP(mut header: *const libc::c_char, mut len: crate::stddef_h::size_t) {
    let mut pkt_header = crate::src::slimproto::RESP_header {
        opcode: [0; 4],
        length: 0,
    };
    crate::stdlib::memset(
        &mut pkt_header as *mut crate::src::slimproto::RESP_header as *mut libc::c_void,
        0 as libc::c_int,
        ::std::mem::size_of::<crate::src::slimproto::RESP_header>() as libc::c_ulong,
    );
    crate::stdlib::memcpy(
        &mut pkt_header.opcode as *mut [libc::c_char; 4] as *mut libc::c_void,
        b"RESP\x00" as *const u8 as *const libc::c_char as *const libc::c_void,
        4 as libc::c_int as libc::c_ulong,
    );
    pkt_header.length = crate::stdlib::htonl(
        (::std::mem::size_of::<crate::src::slimproto::RESP_header>() as libc::c_ulong)
            .wrapping_add(len)
            .wrapping_sub(8 as libc::c_int as libc::c_ulong) as crate::stdlib::uint32_t,
    );
    if loglevel as libc::c_uint >= crate::squeezelite_h::lDEBUG as libc::c_int as libc::c_uint {
        crate::src::utils::logprint(
            b"%s %s:%d RESP\n\x00" as *const u8 as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 9], &[libc::c_char; 9]>(b"sendRESP\x00")).as_ptr(),
            220 as libc::c_int,
        );
    }
    send_packet(
        &mut pkt_header as *mut crate::src::slimproto::RESP_header
            as *mut crate::squeezelite_h::u8_t,
        ::std::mem::size_of::<crate::src::slimproto::RESP_header>() as libc::c_ulong,
    );
    send_packet(header as *mut crate::squeezelite_h::u8_t, len);
}

unsafe extern "C" fn sendMETA(mut meta: *const libc::c_char, mut len: crate::stddef_h::size_t) {
    let mut pkt_header = crate::src::slimproto::META_header {
        opcode: [0; 4],
        length: 0,
    };
    crate::stdlib::memset(
        &mut pkt_header as *mut crate::src::slimproto::META_header as *mut libc::c_void,
        0 as libc::c_int,
        ::std::mem::size_of::<crate::src::slimproto::META_header>() as libc::c_ulong,
    );
    crate::stdlib::memcpy(
        &mut pkt_header.opcode as *mut [libc::c_char; 4] as *mut libc::c_void,
        b"META\x00" as *const u8 as *const libc::c_char as *const libc::c_void,
        4 as libc::c_int as libc::c_ulong,
    );
    pkt_header.length = crate::stdlib::htonl(
        (::std::mem::size_of::<crate::src::slimproto::META_header>() as libc::c_ulong)
            .wrapping_add(len)
            .wrapping_sub(8 as libc::c_int as libc::c_ulong) as crate::stdlib::uint32_t,
    );
    if loglevel as libc::c_uint >= crate::squeezelite_h::lDEBUG as libc::c_int as libc::c_uint {
        crate::src::utils::logprint(
            b"%s %s:%d META\n\x00" as *const u8 as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 9], &[libc::c_char; 9]>(b"sendMETA\x00")).as_ptr(),
            233 as libc::c_int,
        );
    }
    send_packet(
        &mut pkt_header as *mut crate::src::slimproto::META_header
            as *mut crate::squeezelite_h::u8_t,
        ::std::mem::size_of::<crate::src::slimproto::META_header>() as libc::c_ulong,
    );
    send_packet(meta as *mut crate::squeezelite_h::u8_t, len);
}

unsafe extern "C" fn sendSETDName(mut name: *const libc::c_char) {
    let mut pkt_header = crate::src::slimproto::SETD_header {
        opcode: [0; 4],
        length: 0,
        id: 0,
    };
    crate::stdlib::memset(
        &mut pkt_header as *mut crate::src::slimproto::SETD_header as *mut libc::c_void,
        0 as libc::c_int,
        ::std::mem::size_of::<crate::src::slimproto::SETD_header>() as libc::c_ulong,
    );
    crate::stdlib::memcpy(
        &mut pkt_header.opcode as *mut [libc::c_char; 4] as *mut libc::c_void,
        b"SETD\x00" as *const u8 as *const libc::c_char as *const libc::c_void,
        4 as libc::c_int as libc::c_ulong,
    );
    pkt_header.id = 0 as libc::c_int as crate::squeezelite_h::u8_t;
    pkt_header.length = crate::stdlib::htonl(
        (::std::mem::size_of::<crate::src::slimproto::SETD_header>() as libc::c_ulong)
            .wrapping_add(crate::stdlib::strlen(name))
            .wrapping_add(1 as libc::c_int as libc::c_ulong)
            .wrapping_sub(8 as libc::c_int as libc::c_ulong) as crate::stdlib::uint32_t,
    );
    if loglevel as libc::c_uint >= crate::squeezelite_h::lDEBUG as libc::c_int as libc::c_uint {
        crate::src::utils::logprint(
            b"%s %s:%d set playername: %s\n\x00" as *const u8 as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 13], &[libc::c_char; 13]>(b"sendSETDName\x00"))
                .as_ptr(),
            248 as libc::c_int,
            name,
        );
    }
    send_packet(
        &mut pkt_header as *mut crate::src::slimproto::SETD_header
            as *mut crate::squeezelite_h::u8_t,
        ::std::mem::size_of::<crate::src::slimproto::SETD_header>() as libc::c_ulong,
    );
    send_packet(
        name as *mut crate::squeezelite_h::u8_t,
        crate::stdlib::strlen(name).wrapping_add(1 as libc::c_int as libc::c_ulong),
    );
}

unsafe extern "C" fn process_strm(mut pkt: *mut crate::squeezelite_h::u8_t, mut len: libc::c_int) {
    let mut strm = pkt as *mut crate::src::slimproto::strm_packet;
    if loglevel as libc::c_uint >= crate::squeezelite_h::lDEBUG as libc::c_int as libc::c_uint {
        crate::src::utils::logprint(
            b"%s %s:%d strm command %c\n\x00" as *const u8 as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 13], &[libc::c_char; 13]>(b"process_strm\x00"))
                .as_ptr(),
            274 as libc::c_int,
            (*strm).command as libc::c_int,
        );
    }
    let mut current_block_78: u64;
    match (*strm).command as libc::c_int {
        116 => {
            sendSTAT(
                b"STMt\x00" as *const u8 as *const libc::c_char,
                (*strm).replay_gain,
            );
        }
        113 => {
            crate::src::decode::decode_flush();
            crate::src::output::output_flush();
            status.frames_played = 0 as libc::c_int as crate::squeezelite_h::u32_t;
            crate::src::stream::stream_disconnect();
            sendSTAT(
                b"STMf\x00" as *const u8 as *const libc::c_char,
                0 as libc::c_int as crate::squeezelite_h::u32_t,
            );
            crate::src::buffer::buf_flush(streambuf);
        }
        102 => {
            crate::src::decode::decode_flush();
            crate::src::output::output_flush();
            status.frames_played = 0 as libc::c_int as crate::squeezelite_h::u32_t;
            if crate::src::stream::stream_disconnect() {
                sendSTAT(
                    b"STMf\x00" as *const u8 as *const libc::c_char,
                    0 as libc::c_int as crate::squeezelite_h::u32_t,
                );
            }
            crate::src::buffer::buf_flush(streambuf);
        }
        112 => {
            let mut interval = crate::src::utils::unpackN(&mut (*strm).replay_gain);
            crate::stdlib::pthread_mutex_lock(&mut (*outputbuf).mutex);
            output.c2rust_unnamed.pause_frames = interval
                .wrapping_mul(status.current_sample_rate)
                .wrapping_div(1000 as libc::c_int as libc::c_uint);
            if interval != 0 {
                output.state = crate::squeezelite_h::OUTPUT_PAUSE_FRAMES
            } else {
                output.state = crate::squeezelite_h::OUTPUT_STOPPED;
                output.stop_time = crate::src::utils::gettime_ms()
            }
            crate::stdlib::pthread_mutex_unlock(&mut (*outputbuf).mutex);
            if interval == 0 {
                sendSTAT(
                    b"STMp\x00" as *const u8 as *const libc::c_char,
                    0 as libc::c_int as crate::squeezelite_h::u32_t,
                );
            }
            if loglevel as libc::c_uint
                >= crate::squeezelite_h::lDEBUG as libc::c_int as libc::c_uint
            {
                crate::src::utils::logprint(
                    b"%s %s:%d pause interval: %u\n\x00" as *const u8 as *const libc::c_char,
                    crate::src::utils::logtime(),
                    (*::std::mem::transmute::<&[u8; 13], &[libc::c_char; 13]>(b"process_strm\x00"))
                        .as_ptr(),
                    310 as libc::c_int,
                    interval,
                );
            }
        }
        97 => {
            let mut interval_0 = crate::src::utils::unpackN(&mut (*strm).replay_gain);
            crate::stdlib::pthread_mutex_lock(&mut (*outputbuf).mutex);
            output.c2rust_unnamed.skip_frames = interval_0
                .wrapping_mul(status.current_sample_rate)
                .wrapping_div(1000 as libc::c_int as libc::c_uint);
            output.state = crate::squeezelite_h::OUTPUT_SKIP_FRAMES;
            crate::stdlib::pthread_mutex_unlock(&mut (*outputbuf).mutex);
            if loglevel as libc::c_uint
                >= crate::squeezelite_h::lDEBUG as libc::c_int as libc::c_uint
            {
                crate::src::utils::logprint(
                    b"%s %s:%d skip ahead interval: %u\n\x00" as *const u8 as *const libc::c_char,
                    crate::src::utils::logtime(),
                    (*::std::mem::transmute::<&[u8; 13], &[libc::c_char; 13]>(b"process_strm\x00"))
                        .as_ptr(),
                    320 as libc::c_int,
                    interval_0,
                );
            }
        }
        117 => {
            let mut jiffies = crate::src::utils::unpackN(&mut (*strm).replay_gain);
            crate::stdlib::pthread_mutex_lock(&mut (*outputbuf).mutex);
            output.state = if jiffies != 0 {
                crate::squeezelite_h::OUTPUT_START_AT as libc::c_int
            } else {
                crate::squeezelite_h::OUTPUT_RUNNING as libc::c_int
            } as crate::squeezelite_h::output_state;
            output.c2rust_unnamed.start_at = jiffies;
            crate::stdlib::pthread_mutex_unlock(&mut (*outputbuf).mutex);
            if loglevel as libc::c_uint
                >= crate::squeezelite_h::lDEBUG as libc::c_int as libc::c_uint
            {
                crate::src::utils::logprint(
                    b"%s %s:%d unpause at: %u now: %u\n\x00" as *const u8 as *const libc::c_char,
                    crate::src::utils::logtime(),
                    (*::std::mem::transmute::<&[u8; 13], &[libc::c_char; 13]>(b"process_strm\x00"))
                        .as_ptr(),
                    331 as libc::c_int,
                    jiffies,
                    crate::src::utils::gettime_ms(),
                );
            }
            sendSTAT(
                b"STMr\x00" as *const u8 as *const libc::c_char,
                0 as libc::c_int as crate::squeezelite_h::u32_t,
            );
        }
        115 => {
            let mut header_len = (len as libc::c_ulong)
                .wrapping_sub(
                    ::std::mem::size_of::<crate::src::slimproto::strm_packet>() as libc::c_ulong
                ) as libc::c_uint;
            let mut header = pkt.offset(::std::mem::size_of::<crate::src::slimproto::strm_packet>()
                as libc::c_ulong as isize) as *mut libc::c_char;
            let mut ip = (*strm).server_ip;
            let mut port = (*strm).server_port;
            if ip == 0 as libc::c_int as libc::c_uint {
                ip = slimproto_ip
            }
            if loglevel as libc::c_uint
                >= crate::squeezelite_h::lDEBUG as libc::c_int as libc::c_uint
            {
                crate::src::utils::logprint(b"%s %s:%d strm s autostart: %c transition period: %u transition type: %u codec: %c\n\x00"
                             as *const u8 as *const libc::c_char, crate::src::utils::logtime(),
                         (*::std::mem::transmute::<&[u8; 13],
                                                   &[libc::c_char; 13]>(b"process_strm\x00")).as_ptr(),
                         344 as libc::c_int, (*strm).autostart as libc::c_int,
                         (*strm).transition_period as libc::c_int,
                         (*strm).transition_type as libc::c_int - '0' as i32,
                         (*strm).format as libc::c_int);
            }
            autostart = (*strm).autostart as libc::c_int - '0' as i32;
            sendSTAT(
                b"STMf\x00" as *const u8 as *const libc::c_char,
                0 as libc::c_int as crate::squeezelite_h::u32_t,
            );
            if header_len > (4096 as libc::c_int - 1 as libc::c_int) as libc::c_uint {
                if loglevel as libc::c_uint
                    >= crate::squeezelite_h::lWARN as libc::c_int as libc::c_uint
                {
                    crate::src::utils::logprint(
                        b"%s %s:%d header too long: %u\n\x00" as *const u8 as *const libc::c_char,
                        crate::src::utils::logtime(),
                        (*::std::mem::transmute::<&[u8; 13], &[libc::c_char; 13]>(
                            b"process_strm\x00",
                        ))
                        .as_ptr(),
                        350 as libc::c_int,
                        header_len,
                    );
                }
            } else {
                if (*strm).format as libc::c_int != '?' as i32 {
                    crate::src::decode::codec_open(
                        (*strm).format,
                        (*strm).pcm_sample_size,
                        (*strm).pcm_sample_rate,
                        (*strm).pcm_channels,
                        (*strm).pcm_endianness,
                    );
                    current_block_78 = 12758904613967585247;
                } else if autostart >= 2 as libc::c_int {
                    // extension to slimproto to allow server to detect codec from response header and send back in codc message
                    if loglevel as libc::c_uint
                        >= crate::squeezelite_h::lDEBUG as libc::c_int as libc::c_uint
                    {
                        crate::src::utils::logprint(
                            b"%s %s:%d streaming unknown codec\n\x00" as *const u8
                                as *const libc::c_char,
                            crate::src::utils::logtime(),
                            (*::std::mem::transmute::<&[u8; 13], &[libc::c_char; 13]>(
                                b"process_strm\x00",
                            ))
                            .as_ptr(),
                            357 as libc::c_int,
                        );
                    }
                    current_block_78 = 12758904613967585247;
                } else {
                    if loglevel as libc::c_uint
                        >= crate::squeezelite_h::lWARN as libc::c_int as libc::c_uint
                    {
                        crate::src::utils::logprint(
                            b"%s %s:%d unknown codec requires autostart >= 2\n\x00" as *const u8
                                as *const libc::c_char,
                            crate::src::utils::logtime(),
                            (*::std::mem::transmute::<&[u8; 13], &[libc::c_char; 13]>(
                                b"process_strm\x00",
                            ))
                            .as_ptr(),
                            359 as libc::c_int,
                        );
                    }
                    current_block_78 = 15587532755333643506;
                }
                match current_block_78 {
                    15587532755333643506 => {}
                    _ => {
                        if ip == 0x100007f as libc::c_int as libc::c_uint
                            && port as libc::c_int == 0x9b0d as libc::c_int
                        {
                            // extension to slimproto for LocalPlayer - header is filename not http header, don't expect cont
                            crate::src::stream::stream_file(
                                header,
                                header_len as crate::stddef_h::size_t,
                                ((*strm).threshold as libc::c_int * 1024 as libc::c_int)
                                    as libc::c_uint,
                            );
                            autostart -= 2 as libc::c_int
                        } else {
                            crate::src::stream::stream_sock(
                                ip,
                                port,
                                header,
                                header_len as crate::stddef_h::size_t,
                                ((*strm).threshold as libc::c_int * 1024 as libc::c_int)
                                    as libc::c_uint,
                                autostart >= 2 as libc::c_int,
                            );
                        }
                        sendSTAT(
                            b"STMc\x00" as *const u8 as *const libc::c_char,
                            0 as libc::c_int as crate::squeezelite_h::u32_t,
                        );
                        sentSTMl = 0 as libc::c_int != 0;
                        sentSTMo = sentSTMl;
                        sentSTMu = sentSTMo;
                        crate::stdlib::pthread_mutex_lock(&mut (*outputbuf).mutex);
                        output.threshold = (*strm).output_threshold as libc::c_uint;
                        output.next_replay_gain =
                            crate::src::utils::unpackN(&mut (*strm).replay_gain);
                        output.fade_mode = ((*strm).transition_type as libc::c_int - '0' as i32)
                            as crate::squeezelite_h::fade_mode;
                        output.fade_secs = (*strm).transition_period as libc::c_uint;
                        output.invert =
                            (*strm).flags as libc::c_int & 0x3 as libc::c_int == 0x3 as libc::c_int;
                        if loglevel as libc::c_uint
                            >= crate::squeezelite_h::lDEBUG as libc::c_int as libc::c_uint
                        {
                            crate::src::utils::logprint(
                                b"%s %s:%d set fade mode: %u\n\x00" as *const u8
                                    as *const libc::c_char,
                                crate::src::utils::logtime(),
                                (*::std::mem::transmute::<&[u8; 13], &[libc::c_char; 13]>(
                                    b"process_strm\x00",
                                ))
                                .as_ptr(),
                                377 as libc::c_int,
                                output.fade_mode as libc::c_uint,
                            );
                        }
                        crate::stdlib::pthread_mutex_unlock(&mut (*outputbuf).mutex);
                    }
                }
            }
        }
        _ => {
            if loglevel as libc::c_uint
                >= crate::squeezelite_h::lWARN as libc::c_int as libc::c_uint
            {
                crate::src::utils::logprint(
                    b"%s %s:%d unhandled strm %c\n\x00" as *const u8 as *const libc::c_char,
                    crate::src::utils::logtime(),
                    (*::std::mem::transmute::<&[u8; 13], &[libc::c_char; 13]>(b"process_strm\x00"))
                        .as_ptr(),
                    382 as libc::c_int,
                    (*strm).command as libc::c_int,
                );
            }
        }
    };
}

unsafe extern "C" fn process_cont(mut pkt: *mut crate::squeezelite_h::u8_t, mut len: libc::c_int) {
    let mut cont = pkt as *mut crate::src::slimproto::cont_packet;
    (*cont).metaint = crate::src::utils::unpackN(&mut (*cont).metaint);
    if loglevel as libc::c_uint >= crate::squeezelite_h::lDEBUG as libc::c_int as libc::c_uint {
        crate::src::utils::logprint(
            b"%s %s:%d cont metaint: %u loop: %u\n\x00" as *const u8 as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 13], &[libc::c_char; 13]>(b"process_cont\x00"))
                .as_ptr(),
            391 as libc::c_int,
            (*cont).metaint,
            (*cont).loop_0 as libc::c_int,
        );
    }
    if autostart > 1 as libc::c_int {
        autostart -= 2 as libc::c_int;
        crate::stdlib::pthread_mutex_lock(&mut (*streambuf).mutex);
        if stream.state as libc::c_uint
            == crate::squeezelite_h::STREAMING_WAIT as libc::c_int as libc::c_uint
        {
            stream.state = crate::squeezelite_h::STREAMING_BUFFERING;
            stream.meta_next = (*cont).metaint;
            stream.meta_interval = stream.meta_next
        }
        crate::stdlib::pthread_mutex_unlock(&mut (*streambuf).mutex);
        wake_controller();
    };
}

unsafe extern "C" fn process_codc(mut pkt: *mut crate::squeezelite_h::u8_t, mut len: libc::c_int) {
    let mut codc = pkt as *mut crate::src::slimproto::codc_packet;
    if loglevel as libc::c_uint >= crate::squeezelite_h::lDEBUG as libc::c_int as libc::c_uint {
        crate::src::utils::logprint(
            b"%s %s:%d codc: %c\n\x00" as *const u8 as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 13], &[libc::c_char; 13]>(b"process_codc\x00"))
                .as_ptr(),
            408 as libc::c_int,
            (*codc).format as libc::c_int,
        );
    }
    crate::src::decode::codec_open(
        (*codc).format,
        (*codc).pcm_sample_size,
        (*codc).pcm_sample_rate,
        (*codc).pcm_channels,
        (*codc).pcm_endianness,
    );
}

unsafe extern "C" fn process_aude(mut pkt: *mut crate::squeezelite_h::u8_t, mut len: libc::c_int) {
    let mut aude = pkt as *mut crate::src::slimproto::aude_packet;
    if loglevel as libc::c_uint >= crate::squeezelite_h::lDEBUG as libc::c_int as libc::c_uint {
        crate::src::utils::logprint(
            b"%s %s:%d enable spdif: %d dac: %d\n\x00" as *const u8 as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 13], &[libc::c_char; 13]>(b"process_aude\x00"))
                .as_ptr(),
            415 as libc::c_int,
            (*aude).enable_spdif as libc::c_int,
            (*aude).enable_dac as libc::c_int,
        );
    }
    crate::stdlib::pthread_mutex_lock(&mut (*outputbuf).mutex);
    if (*aude).enable_spdif == 0
        && output.state as libc::c_int != crate::squeezelite_h::OUTPUT_OFF as libc::c_int
    {
        output.state = crate::squeezelite_h::OUTPUT_OFF
    }
    if (*aude).enable_spdif as libc::c_int != 0
        && output.state as libc::c_int == crate::squeezelite_h::OUTPUT_OFF as libc::c_int
        && output.idle_to == 0
    {
        output.state = crate::squeezelite_h::OUTPUT_STOPPED;
        output.stop_time = crate::src::utils::gettime_ms()
    }
    crate::stdlib::pthread_mutex_unlock(&mut (*outputbuf).mutex);
}

unsafe extern "C" fn process_audg(mut pkt: *mut crate::squeezelite_h::u8_t, mut len: libc::c_int) {
    let mut audg = pkt as *mut crate::src::slimproto::audg_packet;
    (*audg).gainL = crate::src::utils::unpackN(&mut (*audg).gainL);
    (*audg).gainR = crate::src::utils::unpackN(&mut (*audg).gainR);
    if loglevel as libc::c_uint >= crate::squeezelite_h::lDEBUG as libc::c_int as libc::c_uint {
        crate::src::utils::logprint(
            b"%s %s:%d audg gainL: %u gainR: %u adjust: %u\n\x00" as *const u8
                as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 13], &[libc::c_char; 13]>(b"process_audg\x00"))
                .as_ptr(),
            433 as libc::c_int,
            (*audg).gainL,
            (*audg).gainR,
            (*audg).adjust as libc::c_int,
        );
    }
    crate::src::output_alsa::set_volume(
        if (*audg).adjust as libc::c_int != 0 {
            (*audg).gainL
        } else {
            0x10000 as libc::c_int as libc::c_uint
        },
        if (*audg).adjust as libc::c_int != 0 {
            (*audg).gainR
        } else {
            0x10000 as libc::c_int as libc::c_uint
        },
    );
}

unsafe extern "C" fn process_setd(mut pkt: *mut crate::squeezelite_h::u8_t, mut len: libc::c_int) {
    let mut setd = pkt as *mut crate::src::slimproto::setd_packet;
    // handle player name query and change
    if (*setd).id as libc::c_int == 0 as libc::c_int {
        if len == 5 as libc::c_int {
            if crate::stdlib::strlen(player_name.as_mut_ptr()) != 0 {
                sendSETDName(player_name.as_mut_ptr());
            }
        } else if len > 5 as libc::c_int {
            crate::stdlib::strncpy(
                player_name.as_mut_ptr(),
                (*setd).data.as_mut_ptr(),
                64 as libc::c_int as libc::c_ulong,
            );
            player_name[64 as libc::c_int as usize] = '\u{0}' as i32 as libc::c_char;
            if loglevel as libc::c_uint
                >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint
            {
                crate::src::utils::logprint(
                    b"%s %s:%d set name: %s\n\x00" as *const u8 as *const libc::c_char,
                    crate::src::utils::logtime(),
                    (*::std::mem::transmute::<&[u8; 13], &[libc::c_char; 13]>(b"process_setd\x00"))
                        .as_ptr(),
                    450 as libc::c_int,
                    (*setd).data.as_mut_ptr(),
                );
            }
            // confirm change to server
            sendSETDName((*setd).data.as_mut_ptr());
            // write name to name_file if -N option set
            if !name_file.is_null() {
                let mut fp =
                    crate::stdlib::fopen(name_file, b"w\x00" as *const u8 as *const libc::c_char); // length pack 'n'
                if !fp.is_null() {
                    if loglevel as libc::c_uint
                        >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint
                    {
                        crate::src::utils::logprint(
                            b"%s %s:%d storing name in %s\n\x00" as *const u8
                                as *const libc::c_char,
                            crate::src::utils::logtime(),
                            (*::std::mem::transmute::<&[u8; 13], &[libc::c_char; 13]>(
                                b"process_setd\x00",
                            ))
                            .as_ptr(),
                            457 as libc::c_int,
                            name_file,
                        );
                    }
                    crate::stdlib::fputs(player_name.as_mut_ptr(), fp);
                    crate::stdlib::fclose(fp);
                } else if loglevel as libc::c_uint
                    >= crate::squeezelite_h::lWARN as libc::c_int as libc::c_uint
                {
                    crate::src::utils::logprint(
                        b"%s %s:%d unable to store new name in %s\n\x00" as *const u8
                            as *const libc::c_char,
                        crate::src::utils::logtime(),
                        (*::std::mem::transmute::<&[u8; 13], &[libc::c_char; 13]>(
                            b"process_setd\x00",
                        ))
                        .as_ptr(),
                        461 as libc::c_int,
                        name_file,
                    );
                }
            }
        }
    };
}

unsafe extern "C" fn process_serv(mut pkt: *mut crate::squeezelite_h::u8_t, mut len: libc::c_int) {
    let mut serv = pkt as *mut crate::src::slimproto::serv_packet;
    let mut slimproto_port = 0 as libc::c_int as libc::c_uint;
    let mut squeezeserver: [libc::c_char; 22] =
        *::std::mem::transmute::<&[u8; 22], &mut [libc::c_char; 22]>(b"mysqueezebox.com:3483\x00");
    if *pkt.offset(4 as libc::c_int as isize) as libc::c_int == 0 as libc::c_int
        && *pkt.offset(5 as libc::c_int as isize) as libc::c_int == 0 as libc::c_int
        && *pkt.offset(6 as libc::c_int as isize) as libc::c_int == 0 as libc::c_int
        && *pkt.offset(7 as libc::c_int as isize) as libc::c_int == 1 as libc::c_int
    {
        crate::src::utils::server_addr(
            squeezeserver.as_mut_ptr(),
            &mut new_server,
            &mut slimproto_port,
        );
    } else {
        new_server = (*serv).server_ip
    }
    if loglevel as libc::c_uint >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint {
        crate::src::utils::logprint(
            b"%s %s:%d switch server\n\x00" as *const u8 as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 13], &[libc::c_char; 13]>(b"process_serv\x00"))
                .as_ptr(),
            483 as libc::c_int,
        );
    }
    if (len as libc::c_ulong)
        .wrapping_sub(::std::mem::size_of::<crate::src::slimproto::serv_packet>() as libc::c_ulong)
        == 10 as libc::c_int as libc::c_ulong
    {
        if new_server_cap.is_null() {
            new_server_cap = crate::stdlib::malloc(
                (13 as libc::c_int + 10 as libc::c_int + 1 as libc::c_int) as libc::c_ulong,
            ) as *mut libc::c_char
        }
        *new_server_cap.offset(0 as libc::c_int as isize) = '\u{0}' as i32 as libc::c_char;
        crate::stdlib::strcat(
            new_server_cap,
            b",SyncgroupID=\x00" as *const u8 as *const libc::c_char,
        );
        crate::stdlib::strncat(
            new_server_cap,
            pkt.offset(
                ::std::mem::size_of::<crate::src::slimproto::serv_packet>() as libc::c_ulong
                    as isize,
            ) as *const libc::c_char,
            10 as libc::c_int as libc::c_ulong,
        );
    } else if !new_server_cap.is_null() {
        crate::stdlib::free(new_server_cap as *mut libc::c_void);
        new_server_cap = 0 as *mut libc::c_char
    };
}

static mut handlers: [handler; 8] = unsafe {
    [
        {
            let mut init = handler {
                opcode: [115, 116, 114, 109, 0],
                handler: Some(
                    process_strm
                        as unsafe extern "C" fn(
                            _: *mut crate::squeezelite_h::u8_t,
                            _: libc::c_int,
                        ) -> (),
                ),
            };
            init
        },
        {
            let mut init = handler {
                opcode: [99, 111, 110, 116, 0],
                handler: Some(
                    process_cont
                        as unsafe extern "C" fn(
                            _: *mut crate::squeezelite_h::u8_t,
                            _: libc::c_int,
                        ) -> (),
                ),
            };
            init
        },
        {
            let mut init = handler {
                opcode: [99, 111, 100, 99, 0],
                handler: Some(
                    process_codc
                        as unsafe extern "C" fn(
                            _: *mut crate::squeezelite_h::u8_t,
                            _: libc::c_int,
                        ) -> (),
                ),
            };
            init
        },
        {
            let mut init = handler {
                opcode: [97, 117, 100, 101, 0],
                handler: Some(
                    process_aude
                        as unsafe extern "C" fn(
                            _: *mut crate::squeezelite_h::u8_t,
                            _: libc::c_int,
                        ) -> (),
                ),
            };
            init
        },
        {
            let mut init = handler {
                opcode: [97, 117, 100, 103, 0],
                handler: Some(
                    process_audg
                        as unsafe extern "C" fn(
                            _: *mut crate::squeezelite_h::u8_t,
                            _: libc::c_int,
                        ) -> (),
                ),
            };
            init
        },
        {
            let mut init = handler {
                opcode: [115, 101, 116, 100, 0],
                handler: Some(
                    process_setd
                        as unsafe extern "C" fn(
                            _: *mut crate::squeezelite_h::u8_t,
                            _: libc::c_int,
                        ) -> (),
                ),
            };
            init
        },
        {
            let mut init = handler {
                opcode: [115, 101, 114, 118, 0],
                handler: Some(
                    process_serv
                        as unsafe extern "C" fn(
                            _: *mut crate::squeezelite_h::u8_t,
                            _: libc::c_int,
                        ) -> (),
                ),
            };
            init
        },
        {
            let mut init = handler {
                opcode: [0, 0, 0, 0, 0],
                handler: None,
            };
            init
        },
    ]
};

unsafe extern "C" fn process(mut pack: *mut crate::squeezelite_h::u8_t, mut len: libc::c_int) {
    let mut h = handlers.as_mut_ptr();
    while (*h).handler.is_some()
        && crate::stdlib::strncmp(
            pack as *mut libc::c_char,
            (*h).opcode.as_mut_ptr(),
            4 as libc::c_int as libc::c_ulong,
        ) != 0
    {
        h = h.offset(1)
    }
    if (*h).handler.is_some() {
        if loglevel as libc::c_uint >= crate::squeezelite_h::lDEBUG as libc::c_int as libc::c_uint {
            crate::src::utils::logprint(
                b"%s %s:%d %s\n\x00" as *const u8 as *const libc::c_char,
                crate::src::utils::logtime(),
                (*::std::mem::transmute::<&[u8; 8], &[libc::c_char; 8]>(b"process\x00")).as_ptr(),
                521 as libc::c_int,
                (*h).opcode.as_mut_ptr(),
            );
        }
        (*h).handler.expect("non-null function pointer")(pack, len);
    } else {
        *pack.offset(4 as libc::c_int as isize) = '\u{0}' as i32 as crate::squeezelite_h::u8_t;
        if loglevel as libc::c_uint >= crate::squeezelite_h::lWARN as libc::c_int as libc::c_uint {
            crate::src::utils::logprint(
                b"%s %s:%d unhandled %s\n\x00" as *const u8 as *const libc::c_char,
                crate::src::utils::logtime(),
                (*::std::mem::transmute::<&[u8; 8], &[libc::c_char; 8]>(b"process\x00")).as_ptr(),
                525 as libc::c_int,
                pack as *mut libc::c_char,
            );
        }
    };
}

static mut running: bool = false;

unsafe extern "C" fn slimproto_run() {
    static mut buffer: [crate::squeezelite_h::u8_t; 4096] = [0; 4096];
    let mut expect = 0 as libc::c_int;
    let mut got = 0 as libc::c_int;
    let mut now: crate::squeezelite_h::u32_t = 0;
    static mut last: crate::squeezelite_h::u32_t = 0 as libc::c_int as crate::squeezelite_h::u32_t;
    let mut ehandles: [crate::stdlib::pollfd; 2] = [crate::stdlib::pollfd {
        fd: 0,
        events: 0,
        revents: 0,
    }; 2];
    let mut timeouts = 0 as libc::c_int;
    crate::src::utils::set_readwake_handles(ehandles.as_mut_ptr(), sock, wake_e);
    while running as libc::c_int != 0 && new_server == 0 {
        let mut wake = 0 as libc::c_int != 0;
        let mut ev = crate::squeezelite_h::EVENT_TIMEOUT;
        ev = crate::src::utils::wait_readwake(ehandles.as_mut_ptr(), 1000 as libc::c_int);
        if ev as libc::c_uint != crate::squeezelite_h::EVENT_TIMEOUT as libc::c_int as libc::c_uint
        {
            if ev as libc::c_uint == crate::squeezelite_h::EVENT_READ as libc::c_int as libc::c_uint
            {
                if expect > 0 as libc::c_int {
                    let mut n = crate::stdlib::recv(
                        sock,
                        buffer.as_mut_ptr().offset(got as isize) as *mut libc::c_void,
                        expect as crate::stddef_h::size_t,
                        0 as libc::c_int,
                    ) as libc::c_int;
                    if n <= 0 as libc::c_int {
                        if n < 0 as libc::c_int
                            && *crate::stdlib::__errno_location() == 11 as libc::c_int
                        {
                            continue;
                        }
                        if loglevel as libc::c_uint
                            >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint
                        {
                            crate::src::utils::logprint(
                                b"%s %s:%d error reading from socket: %s\n\x00" as *const u8
                                    as *const libc::c_char,
                                crate::src::utils::logtime(),
                                (*::std::mem::transmute::<&[u8; 14], &[libc::c_char; 14]>(
                                    b"slimproto_run\x00",
                                ))
                                .as_ptr(),
                                557 as libc::c_int,
                                if n != 0 {
                                    crate::stdlib::strerror(*crate::stdlib::__errno_location())
                                        as *const libc::c_char
                                } else {
                                    b"closed\x00" as *const u8 as *const libc::c_char
                                },
                            );
                        }
                        return;
                    } else {
                        expect -= n;
                        got += n;
                        if expect == 0 as libc::c_int {
                            process(buffer.as_mut_ptr(), got);
                            got = 0 as libc::c_int
                        }
                    }
                } else if expect == 0 as libc::c_int {
                    let mut n_0 = crate::stdlib::recv(
                        sock,
                        buffer.as_mut_ptr().offset(got as isize) as *mut libc::c_void,
                        (2 as libc::c_int - got) as crate::stddef_h::size_t,
                        0 as libc::c_int,
                    ) as libc::c_int;
                    if n_0 <= 0 as libc::c_int {
                        if n_0 < 0 as libc::c_int
                            && *crate::stdlib::__errno_location() == 11 as libc::c_int
                        {
                            continue;
                        }
                        if loglevel as libc::c_uint
                            >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint
                        {
                            crate::src::utils::logprint(
                                b"%s %s:%d error reading from socket: %s\n\x00" as *const u8
                                    as *const libc::c_char,
                                crate::src::utils::logtime(),
                                (*::std::mem::transmute::<&[u8; 14], &[libc::c_char; 14]>(
                                    b"slimproto_run\x00",
                                ))
                                .as_ptr(),
                                572 as libc::c_int,
                                if n_0 != 0 {
                                    crate::stdlib::strerror(*crate::stdlib::__errno_location())
                                        as *const libc::c_char
                                } else {
                                    b"closed\x00" as *const u8 as *const libc::c_char
                                },
                            );
                        }
                        return;
                    } else {
                        got += n_0;
                        if got == 2 as libc::c_int {
                            expect = (buffer[0 as libc::c_int as usize] as libc::c_int)
                                << 8 as libc::c_int
                                | buffer[1 as libc::c_int as usize] as libc::c_int;
                            got = 0 as libc::c_int;
                            if expect > 4096 as libc::c_int {
                                crate::src::utils::logprint(
                                    b"%s %s:%d FATAL: slimproto packet too big: %d > %d\n\x00"
                                        as *const u8
                                        as *const libc::c_char,
                                    crate::src::utils::logtime(),
                                    (*::std::mem::transmute::<&[u8; 14], &[libc::c_char; 14]>(
                                        b"slimproto_run\x00",
                                    ))
                                    .as_ptr(),
                                    580 as libc::c_int,
                                    expect,
                                    4096 as libc::c_int,
                                );
                                return;
                            }
                        }
                    }
                } else {
                    crate::src::utils::logprint(
                        b"%s %s:%d FATAL: negative expect\n\x00" as *const u8
                            as *const libc::c_char,
                        crate::src::utils::logtime(),
                        (*::std::mem::transmute::<&[u8; 14], &[libc::c_char; 14]>(
                            b"slimproto_run\x00",
                        ))
                        .as_ptr(),
                        585 as libc::c_int,
                    );
                    return;
                }
            }
            if ev as libc::c_uint == crate::squeezelite_h::EVENT_WAKE as libc::c_int as libc::c_uint
            {
                wake = 1 as libc::c_int != 0
            }
            timeouts = 0 as libc::c_int
        } else {
            timeouts += 1;
            if timeouts > 35 as libc::c_int {
                // expect message from server every 5 seconds, but 30 seconds on mysb.com so timeout after 35 seconds
                if loglevel as libc::c_uint
                    >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint
                {
                    crate::src::utils::logprint(
                        b"%s %s:%d No messages from server - connection dead\n\x00" as *const u8
                            as *const libc::c_char,
                        crate::src::utils::logtime(),
                        (*::std::mem::transmute::<&[u8; 14], &[libc::c_char; 14]>(
                            b"slimproto_run\x00",
                        ))
                        .as_ptr(),
                        600 as libc::c_int,
                    );
                }
                return;
            }
        }
        // update playback state when woken or every 100ms
        now = crate::src::utils::gettime_ms();
        if wake as libc::c_int != 0
            || now.wrapping_sub(last) > 100 as libc::c_int as libc::c_uint
            || last > now
        {
            let mut _sendSTMs = 0 as libc::c_int != 0;
            let mut _sendDSCO = 0 as libc::c_int != 0;
            let mut _sendRESP = 0 as libc::c_int != 0;
            let mut _sendMETA = 0 as libc::c_int != 0;
            let mut _sendSTMd = 0 as libc::c_int != 0;
            let mut _sendSTMt = 0 as libc::c_int != 0;
            let mut _sendSTMl = 0 as libc::c_int != 0;
            let mut _sendSTMu = 0 as libc::c_int != 0;
            let mut _sendSTMo = 0 as libc::c_int != 0;
            let mut _sendSTMn = 0 as libc::c_int != 0;
            let mut _stream_disconnect = 0 as libc::c_int != 0;
            let mut _start_output = 0 as libc::c_int != 0;
            let mut _decode_state = crate::squeezelite_h::DECODE_STOPPED;
            let mut disconnect_code = crate::squeezelite_h::DISCONNECT_OK;
            static mut header: [libc::c_char; 4096] = [0; 4096];
            let mut header_len = 0 as libc::c_int as crate::stddef_h::size_t;
            last = now;
            crate::stdlib::pthread_mutex_lock(&mut (*streambuf).mutex);
            status.stream_full = crate::squeezelite_h::_buf_used(streambuf);
            status.stream_size = (*streambuf).size as crate::squeezelite_h::u32_t;
            status.stream_bytes = stream.bytes;
            status.stream_state = stream.state;
            if stream.state as libc::c_uint
                == crate::squeezelite_h::DISCONNECT as libc::c_int as libc::c_uint
            {
                disconnect_code = stream.disconnect;
                stream.state = crate::squeezelite_h::STOPPED;
                _sendDSCO = 1 as libc::c_int != 0
            }
            if !stream.sent_headers
                && (stream.state as libc::c_uint
                    == crate::squeezelite_h::STREAMING_HTTP as libc::c_int as libc::c_uint
                    || stream.state as libc::c_uint
                        == crate::squeezelite_h::STREAMING_WAIT as libc::c_int as libc::c_uint
                    || stream.state as libc::c_uint
                        == crate::squeezelite_h::STREAMING_BUFFERING as libc::c_int as libc::c_uint)
            {
                header_len = stream.header_len;
                crate::stdlib::memcpy(
                    header.as_mut_ptr() as *mut libc::c_void,
                    stream.header as *const libc::c_void,
                    header_len,
                );
                _sendRESP = 1 as libc::c_int != 0;
                stream.sent_headers = 1 as libc::c_int != 0
            }
            if stream.meta_send {
                header_len = stream.header_len;
                crate::stdlib::memcpy(
                    header.as_mut_ptr() as *mut libc::c_void,
                    stream.header as *const libc::c_void,
                    header_len,
                );
                _sendMETA = 1 as libc::c_int != 0;
                stream.meta_send = 0 as libc::c_int != 0
            }
            crate::stdlib::pthread_mutex_unlock(&mut (*streambuf).mutex);
            crate::stdlib::pthread_mutex_lock(&mut decode.mutex);
            if (status.stream_state as libc::c_uint
                == crate::squeezelite_h::STREAMING_HTTP as libc::c_int as libc::c_uint
                || status.stream_state as libc::c_uint
                    == crate::squeezelite_h::STREAMING_FILE as libc::c_int as libc::c_uint
                || status.stream_state as libc::c_uint
                    == crate::squeezelite_h::DISCONNECT as libc::c_int as libc::c_uint
                    && stream.disconnect as libc::c_uint
                        == crate::squeezelite_h::DISCONNECT_OK as libc::c_int as libc::c_uint)
                && !sentSTMl
                && decode.state as libc::c_uint
                    == crate::squeezelite_h::DECODE_READY as libc::c_int as libc::c_uint
            {
                if autostart == 0 as libc::c_int {
                    decode.state = crate::squeezelite_h::DECODE_RUNNING;
                    _sendSTMl = 1 as libc::c_int != 0;
                    sentSTMl = 1 as libc::c_int != 0
                } else if autostart == 1 as libc::c_int {
                    decode.state = crate::squeezelite_h::DECODE_RUNNING;
                    _start_output = 1 as libc::c_int != 0
                }
                // autostart 2 and 3 require cont to be received first
            }
            if decode.state as libc::c_uint
                == crate::squeezelite_h::DECODE_COMPLETE as libc::c_int as libc::c_uint
                || decode.state as libc::c_uint
                    == crate::squeezelite_h::DECODE_ERROR as libc::c_int as libc::c_uint
            {
                if decode.state as libc::c_uint
                    == crate::squeezelite_h::DECODE_COMPLETE as libc::c_int as libc::c_uint
                {
                    _sendSTMd = 1 as libc::c_int != 0
                }
                if decode.state as libc::c_uint
                    == crate::squeezelite_h::DECODE_ERROR as libc::c_int as libc::c_uint
                {
                    _sendSTMn = 1 as libc::c_int != 0
                }
                decode.state = crate::squeezelite_h::DECODE_STOPPED;
                if status.stream_state as libc::c_uint
                    == crate::squeezelite_h::STREAMING_HTTP as libc::c_int as libc::c_uint
                    || status.stream_state as libc::c_uint
                        == crate::squeezelite_h::STREAMING_FILE as libc::c_int as libc::c_uint
                {
                    _stream_disconnect = 1 as libc::c_int != 0
                }
            }
            _decode_state = decode.state;
            crate::stdlib::pthread_mutex_unlock(&mut decode.mutex);
            crate::stdlib::pthread_mutex_lock(&mut (*outputbuf).mutex);
            status.output_full = crate::squeezelite_h::_buf_used(outputbuf);
            status.output_size = (*outputbuf).size as crate::squeezelite_h::u32_t;
            status.frames_played = output.frames_played_dmp;
            status.current_sample_rate = output.current_sample_rate;
            status.updated = output.updated;
            status.device_frames = output.device_frames;
            if output.track_started {
                _sendSTMs = 1 as libc::c_int != 0;
                output.track_started = 0 as libc::c_int != 0;
                status.stream_start = output.track_start_time
            }
            if _start_output as libc::c_int != 0
                && (output.state as libc::c_int
                    == crate::squeezelite_h::OUTPUT_STOPPED as libc::c_int
                    || output.state as libc::c_int
                        == crate::squeezelite_h::OUTPUT_OFF as libc::c_int)
            {
                output.state = crate::squeezelite_h::OUTPUT_BUFFER
            }
            if output.state as libc::c_int == crate::squeezelite_h::OUTPUT_RUNNING as libc::c_int
                && !sentSTMu
                && status.output_full == 0 as libc::c_int as libc::c_uint
                && status.stream_state as libc::c_uint
                    <= crate::squeezelite_h::DISCONNECT as libc::c_int as libc::c_uint
                && _decode_state as libc::c_uint
                    == crate::squeezelite_h::DECODE_STOPPED as libc::c_int as libc::c_uint
            {
                _sendSTMu = 1 as libc::c_int != 0;
                sentSTMu = 1 as libc::c_int != 0;
                if loglevel as libc::c_uint
                    >= crate::squeezelite_h::lDEBUG as libc::c_int as libc::c_uint
                {
                    crate::src::utils::logprint(
                        b"%s %s:%d output underrun\n\x00" as *const u8 as *const libc::c_char,
                        crate::src::utils::logtime(),
                        (*::std::mem::transmute::<&[u8; 14], &[libc::c_char; 14]>(
                            b"slimproto_run\x00",
                        ))
                        .as_ptr(),
                        709 as libc::c_int,
                    );
                }
                output.state = crate::squeezelite_h::OUTPUT_STOPPED;
                output.stop_time = now
            }
            if output.state as libc::c_int == crate::squeezelite_h::OUTPUT_RUNNING as libc::c_int
                && !sentSTMo
                && status.output_full == 0 as libc::c_int as libc::c_uint
                && status.stream_state as libc::c_uint
                    == crate::squeezelite_h::STREAMING_HTTP as libc::c_int as libc::c_uint
            {
                _sendSTMo = 1 as libc::c_int != 0;
                sentSTMo = 1 as libc::c_int != 0
            }
            if output.state as libc::c_int == crate::squeezelite_h::OUTPUT_STOPPED as libc::c_int
                && output.idle_to != 0
                && now.wrapping_sub(output.stop_time) > output.idle_to
            {
                output.state = crate::squeezelite_h::OUTPUT_OFF;
                if loglevel as libc::c_uint
                    >= crate::squeezelite_h::lDEBUG as libc::c_int as libc::c_uint
                {
                    crate::src::utils::logprint(
                        b"%s %s:%d output timeout\n\x00" as *const u8 as *const libc::c_char,
                        crate::src::utils::logtime(),
                        (*::std::mem::transmute::<&[u8; 14], &[libc::c_char; 14]>(
                            b"slimproto_run\x00",
                        ))
                        .as_ptr(),
                        720 as libc::c_int,
                    );
                }
            }
            if output.state as libc::c_int == crate::squeezelite_h::OUTPUT_RUNNING as libc::c_int
                && now.wrapping_sub(status.last) > 1000 as libc::c_int as libc::c_uint
            {
                _sendSTMt = 1 as libc::c_int != 0;
                status.last = now
            }
            crate::stdlib::pthread_mutex_unlock(&mut (*outputbuf).mutex);
            if _stream_disconnect {
                crate::src::stream::stream_disconnect();
            }
            // send packets once locks released as packet sending can block
            if _sendDSCO {
                sendDSCO(disconnect_code);
            }
            if _sendSTMs {
                sendSTAT(
                    b"STMs\x00" as *const u8 as *const libc::c_char,
                    0 as libc::c_int as crate::squeezelite_h::u32_t,
                );
            }
            if _sendSTMd {
                sendSTAT(
                    b"STMd\x00" as *const u8 as *const libc::c_char,
                    0 as libc::c_int as crate::squeezelite_h::u32_t,
                );
            }
            if _sendSTMt {
                sendSTAT(
                    b"STMt\x00" as *const u8 as *const libc::c_char,
                    0 as libc::c_int as crate::squeezelite_h::u32_t,
                );
            }
            if _sendSTMl {
                sendSTAT(
                    b"STMl\x00" as *const u8 as *const libc::c_char,
                    0 as libc::c_int as crate::squeezelite_h::u32_t,
                );
            }
            if _sendSTMu {
                sendSTAT(
                    b"STMu\x00" as *const u8 as *const libc::c_char,
                    0 as libc::c_int as crate::squeezelite_h::u32_t,
                );
            }
            if _sendSTMo {
                sendSTAT(
                    b"STMo\x00" as *const u8 as *const libc::c_char,
                    0 as libc::c_int as crate::squeezelite_h::u32_t,
                );
            }
            if _sendSTMn {
                sendSTAT(
                    b"STMn\x00" as *const u8 as *const libc::c_char,
                    0 as libc::c_int as crate::squeezelite_h::u32_t,
                );
            }
            if _sendRESP {
                sendRESP(header.as_mut_ptr(), header_len);
            }
            if _sendMETA {
                sendMETA(header.as_mut_ptr(), header_len);
            }
        }
    }
}
// called from other threads to wake state machine above
#[no_mangle]

pub unsafe extern "C" fn wake_controller() {
    crate::stdlib::eventfd_write(wake_e, 1 as libc::c_int as crate::stdlib::eventfd_t);
}
#[no_mangle]

pub unsafe extern "C" fn discover_server(
    mut default_server: *mut libc::c_char,
) -> crate::stdlib::in_addr_t {
    let mut d = crate::stdlib::sockaddr_in {
        sin_family: 0,
        sin_port: 0,
        sin_addr: crate::stdlib::in_addr { s_addr: 0 },
        sin_zero: [0; 8],
    };
    let mut s = crate::stdlib::sockaddr_in {
        sin_family: 0,
        sin_port: 0,
        sin_addr: crate::stdlib::in_addr { s_addr: 0 },
        sin_zero: [0; 8],
    };
    let mut buf = 0 as *mut libc::c_char;
    let mut pollinfo = crate::stdlib::pollfd {
        fd: 0,
        events: 0,
        revents: 0,
    };
    let mut port: libc::c_uint = 0;
    let mut disc_sock = crate::stdlib::socket(
        2 as libc::c_int,
        crate::stdlib::SOCK_DGRAM as libc::c_int,
        0 as libc::c_int,
    );
    let mut enable = 1 as libc::c_int as crate::stdlib::socklen_t;
    crate::stdlib::setsockopt(
        disc_sock,
        1 as libc::c_int,
        6 as libc::c_int,
        &mut enable as *mut crate::stdlib::socklen_t as *const libc::c_void,
        ::std::mem::size_of::<crate::stdlib::socklen_t>() as libc::c_ulong
            as crate::stdlib::socklen_t,
    );
    buf = b"e\x00" as *const u8 as *const libc::c_char as *mut libc::c_char;
    crate::stdlib::memset(
        &mut d as *mut crate::stdlib::sockaddr_in as *mut libc::c_void,
        0 as libc::c_int,
        ::std::mem::size_of::<crate::stdlib::sockaddr_in>() as libc::c_ulong,
    );
    d.sin_family = 2 as libc::c_int as crate::stdlib::sa_family_t;
    d.sin_port = crate::stdlib::htons(3483 as libc::c_int as crate::stdlib::uint16_t);
    d.sin_addr.s_addr = crate::stdlib::htonl(0xffffffff as libc::c_uint);
    pollinfo.fd = disc_sock;
    pollinfo.events = 0x1 as libc::c_int as libc::c_short;
    loop {
        if loglevel as libc::c_uint >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint {
            crate::src::utils::logprint(
                b"%s %s:%d sending discovery\n\x00" as *const u8 as *const libc::c_char,
                crate::src::utils::logtime(),
                (*::std::mem::transmute::<&[u8; 16], &[libc::c_char; 16]>(b"discover_server\x00"))
                    .as_ptr(),
                788 as libc::c_int,
            );
        }
        crate::stdlib::memset(
            &mut s as *mut crate::stdlib::sockaddr_in as *mut libc::c_void,
            0 as libc::c_int,
            ::std::mem::size_of::<crate::stdlib::sockaddr_in>() as libc::c_ulong,
        );
        if crate::stdlib::sendto(
            disc_sock,
            buf as *const libc::c_void,
            1 as libc::c_int as crate::stddef_h::size_t,
            0 as libc::c_int,
            &mut d as *mut crate::stdlib::sockaddr_in as *mut crate::stdlib::sockaddr,
            ::std::mem::size_of::<crate::stdlib::sockaddr_in>() as libc::c_ulong
                as crate::stdlib::socklen_t,
        ) < 0 as libc::c_int as libc::c_long
        {
            if loglevel as libc::c_uint
                >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint
            {
                crate::src::utils::logprint(
                    b"%s %s:%d error sending disovery\n\x00" as *const u8 as *const libc::c_char,
                    crate::src::utils::logtime(),
                    (*::std::mem::transmute::<&[u8; 16], &[libc::c_char; 16]>(
                        b"discover_server\x00",
                    ))
                    .as_ptr(),
                    792 as libc::c_int,
                );
            }
        }
        if crate::stdlib::poll(
            &mut pollinfo,
            1 as libc::c_int as crate::stdlib::nfds_t,
            5000 as libc::c_int,
        ) == 1 as libc::c_int
        {
            let mut readbuf: [libc::c_char; 10] = [0; 10];
            let mut slen = ::std::mem::size_of::<crate::stdlib::sockaddr_in>() as libc::c_ulong
                as crate::stdlib::socklen_t;
            crate::stdlib::recvfrom(
                disc_sock,
                readbuf.as_mut_ptr() as *mut libc::c_void,
                10 as libc::c_int as crate::stddef_h::size_t,
                0 as libc::c_int,
                &mut s as *mut crate::stdlib::sockaddr_in as *mut crate::stdlib::sockaddr,
                &mut slen,
            );
            if loglevel as libc::c_uint
                >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint
            {
                crate::src::utils::logprint(
                    b"%s %s:%d got response from: %s:%d\n\x00" as *const u8 as *const libc::c_char,
                    crate::src::utils::logtime(),
                    (*::std::mem::transmute::<&[u8; 16], &[libc::c_char; 16]>(
                        b"discover_server\x00",
                    ))
                    .as_ptr(),
                    799 as libc::c_int,
                    crate::stdlib::inet_ntoa(s.sin_addr),
                    crate::stdlib::ntohs(s.sin_port) as libc::c_int,
                );
            }
        }
        if !default_server.is_null() {
            crate::src::utils::server_addr(default_server, &mut s.sin_addr.s_addr, &mut port);
        }
        if !(s.sin_addr.s_addr == 0 as libc::c_int as libc::c_uint && running as libc::c_int != 0) {
            break;
        }
    }
    crate::stdlib::close(disc_sock);
    return s.sin_addr.s_addr;
}
#[no_mangle]

pub unsafe extern "C" fn slimproto(
    mut level: crate::squeezelite_h::log_level,
    mut server: *mut libc::c_char,
    mut mac: *mut crate::squeezelite_h::u8_t,
    mut name: *const libc::c_char,
    mut namefile: *const libc::c_char,
    mut modelname: *const libc::c_char,
    mut maxSampleRate: libc::c_int,
) {
    let mut serv_addr = crate::stdlib::sockaddr_in {
        sin_family: 0,
        sin_port: 0,
        sin_addr: crate::stdlib::in_addr { s_addr: 0 },
        sin_zero: [0; 8],
    };
    static mut fixed_cap: [libc::c_char; 256] = [0; 256];
    static mut var_cap: [libc::c_char; 128] = [
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 0, 0, 0, 0, 0, 0, 0,
    ];
    let mut reconnect = 0 as libc::c_int != 0;
    let mut failed_connect = 0 as libc::c_int as libc::c_uint;
    let mut slimproto_port = 0 as libc::c_int as libc::c_uint;
    let mut previous_server = 0 as libc::c_int as crate::stdlib::in_addr_t;
    let mut i: libc::c_int = 0;
    crate::stdlib::memset(
        &mut status as *mut C2RustUnnamed_17 as *mut libc::c_void,
        0 as libc::c_int,
        ::std::mem::size_of::<C2RustUnnamed_17>() as libc::c_ulong,
    );
    wake_e = crate::stdlib::eventfd(0 as libc::c_int as libc::c_uint, 0 as libc::c_int);
    loglevel = level;
    running = 1 as libc::c_int != 0;
    if !server.is_null() {
        crate::src::utils::server_addr(server, &mut slimproto_ip, &mut slimproto_port);
    }
    if slimproto_ip == 0 {
        slimproto_ip = discover_server(server)
    }
    if slimproto_port == 0 {
        slimproto_port = 3483 as libc::c_int as libc::c_uint
    }
    if !name.is_null() {
        crate::stdlib::strncpy(
            player_name.as_mut_ptr(),
            name,
            64 as libc::c_int as libc::c_ulong,
        );
        player_name[64 as libc::c_int as usize] = '\u{0}' as i32 as libc::c_char
    }
    if !namefile.is_null() {
        let mut fp = 0 as *mut crate::stdlib::FILE;
        name_file = namefile;
        fp = crate::stdlib::fopen(namefile, b"r\x00" as *const u8 as *const libc::c_char);
        if !fp.is_null() {
            if crate::stdlib::fgets(player_name.as_mut_ptr(), 64 as libc::c_int, fp).is_null() {
                player_name[64 as libc::c_int as usize] = '\u{0}' as i32 as libc::c_char
            } else {
                // strip any \n from fgets response
                let mut len = crate::stdlib::strlen(player_name.as_mut_ptr()) as libc::c_int;
                if len > 0 as libc::c_int
                    && player_name[(len - 1 as libc::c_int) as usize] as libc::c_int == '\n' as i32
                {
                    player_name[(len - 1 as libc::c_int) as usize] = '\u{0}' as i32 as libc::c_char
                }
                if loglevel as libc::c_uint
                    >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint
                {
                    crate::src::utils::logprint(
                        b"%s %s:%d retrieved name %s from %s\n\x00" as *const u8
                            as *const libc::c_char,
                        crate::src::utils::logtime(),
                        (*::std::mem::transmute::<&[u8; 10], &[libc::c_char; 10]>(
                            b"slimproto\x00",
                        ))
                        .as_ptr(),
                        862 as libc::c_int,
                        player_name.as_mut_ptr(),
                        name_file,
                    );
                }
            }
            crate::stdlib::fclose(fp);
        }
    }
    if !running {
        return;
    }
    crate::stdlib::pthread_mutex_lock(&mut (*outputbuf).mutex);
    crate::stdlib::snprintf(
        fixed_cap.as_mut_ptr(),
        256 as libc::c_int as libc::c_ulong,
        b",ModelName=%s,MaxSampleRate=%u\x00" as *const u8 as *const libc::c_char,
        if !modelname.is_null() {
            modelname
        } else {
            b"SqueezeLite\x00" as *const u8 as *const libc::c_char
        },
        if maxSampleRate > 0 as libc::c_int {
            maxSampleRate as libc::c_uint
        } else {
            output.supported_rates[0 as libc::c_int as usize]
        },
    );
    i = 0 as libc::c_int;
    while i < 10 as libc::c_int {
        if !(*codecs.as_mut_ptr().offset(i as isize)).is_null()
            && (**codecs.as_mut_ptr().offset(i as isize)).id as libc::c_int != 0
            && crate::stdlib::strlen(fixed_cap.as_mut_ptr())
                < (256 as libc::c_int - 10 as libc::c_int) as libc::c_ulong
        {
            crate::stdlib::strcat(
                fixed_cap.as_mut_ptr(),
                b",\x00" as *const u8 as *const libc::c_char,
            );
            crate::stdlib::strcat(
                fixed_cap.as_mut_ptr(),
                (**codecs.as_mut_ptr().offset(i as isize)).types,
            );
        }
        i += 1
    }
    crate::stdlib::pthread_mutex_unlock(&mut (*outputbuf).mutex);
    crate::stdlib::memset(
        &mut serv_addr as *mut crate::stdlib::sockaddr_in as *mut libc::c_void,
        0 as libc::c_int,
        ::std::mem::size_of::<crate::stdlib::sockaddr_in>() as libc::c_ulong,
    );
    serv_addr.sin_family = 2 as libc::c_int as crate::stdlib::sa_family_t;
    serv_addr.sin_addr.s_addr = slimproto_ip;
    serv_addr.sin_port = crate::stdlib::htons(slimproto_port as crate::stdlib::uint16_t);
    if loglevel as libc::c_uint >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint {
        crate::src::utils::logprint(
            b"%s %s:%d connecting to %s:%d\n\x00" as *const u8 as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 10], &[libc::c_char; 10]>(b"slimproto\x00")).as_ptr(),
            887 as libc::c_int,
            crate::stdlib::inet_ntoa(serv_addr.sin_addr),
            crate::stdlib::ntohs(serv_addr.sin_port) as libc::c_int,
        );
    }
    new_server = 0 as libc::c_int as crate::squeezelite_h::u32_t;
    while running {
        if new_server != 0 {
            previous_server = slimproto_ip;
            serv_addr.sin_addr.s_addr = new_server;
            slimproto_ip = serv_addr.sin_addr.s_addr;
            if loglevel as libc::c_uint
                >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint
            {
                crate::src::utils::logprint(
                    b"%s %s:%d switching server to %s:%d\n\x00" as *const u8 as *const libc::c_char,
                    crate::src::utils::logtime(),
                    (*::std::mem::transmute::<&[u8; 10], &[libc::c_char; 10]>(b"slimproto\x00"))
                        .as_ptr(),
                    896 as libc::c_int,
                    crate::stdlib::inet_ntoa(serv_addr.sin_addr),
                    crate::stdlib::ntohs(serv_addr.sin_port) as libc::c_int,
                );
            }
            new_server = 0 as libc::c_int as crate::squeezelite_h::u32_t;
            reconnect = 0 as libc::c_int != 0
        }
        sock = crate::stdlib::socket(
            2 as libc::c_int,
            crate::stdlib::SOCK_STREAM as libc::c_int,
            0 as libc::c_int,
        );
        crate::src::utils::set_nonblock(sock);
        if crate::src::utils::connect_timeout(
            sock,
            &mut serv_addr as *mut crate::stdlib::sockaddr_in as *mut crate::stdlib::sockaddr,
            ::std::mem::size_of::<crate::stdlib::sockaddr_in>() as libc::c_ulong
                as crate::stdlib::socklen_t,
            5 as libc::c_int,
        ) != 0 as libc::c_int
        {
            if previous_server != 0 {
                serv_addr.sin_addr.s_addr = previous_server;
                slimproto_ip = serv_addr.sin_addr.s_addr;
                if loglevel as libc::c_uint
                    >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint
                {
                    crate::src::utils::logprint(b"%s %s:%d new server not reachable, reverting to previous server %s:%d\n\x00"
                                 as *const u8 as *const libc::c_char,
                             crate::src::utils::logtime(),
                             (*::std::mem::transmute::<&[u8; 10],
                                                       &[libc::c_char; 10]>(b"slimproto\x00")).as_ptr(),
                             910 as libc::c_int,
                             crate::stdlib::inet_ntoa(serv_addr.sin_addr),
                             crate::stdlib::ntohs(serv_addr.sin_port) as libc::c_int);
                }
            } else {
                if loglevel as libc::c_uint
                    >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint
                {
                    crate::src::utils::logprint(
                        b"%s %s:%d unable to connect to server %u\n\x00" as *const u8
                            as *const libc::c_char,
                        crate::src::utils::logtime(),
                        (*::std::mem::transmute::<&[u8; 10], &[libc::c_char; 10]>(
                            b"slimproto\x00",
                        ))
                        .as_ptr(),
                        912 as libc::c_int,
                        failed_connect,
                    );
                }
                crate::stdlib::sleep(5 as libc::c_int as libc::c_uint);
            }
            // rediscover server if it was not set at startup
            if server.is_null() && {
                failed_connect = failed_connect.wrapping_add(1);
                (failed_connect) > 5 as libc::c_int as libc::c_uint
            } {
                serv_addr.sin_addr.s_addr = discover_server(0 as *mut libc::c_char);
                slimproto_ip = serv_addr.sin_addr.s_addr
            }
        } else {
            let mut our_addr = crate::stdlib::sockaddr_in {
                sin_family: 0,
                sin_port: 0,
                sin_addr: crate::stdlib::in_addr { s_addr: 0 },
                sin_zero: [0; 8],
            };
            let mut len_0: crate::stdlib::socklen_t = 0;
            if loglevel as libc::c_uint
                >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint
            {
                crate::src::utils::logprint(
                    b"%s %s:%d connected\n\x00" as *const u8 as *const libc::c_char,
                    crate::src::utils::logtime(),
                    (*::std::mem::transmute::<&[u8; 10], &[libc::c_char; 10]>(b"slimproto\x00"))
                        .as_ptr(),
                    926 as libc::c_int,
                );
            }
            var_cap[0 as libc::c_int as usize] = '\u{0}' as i32 as libc::c_char;
            failed_connect = 0 as libc::c_int as libc::c_uint;
            // check if this is a local player now we are connected & signal to server via 'loc' format
            // this requires LocalPlayer server plugin to enable direct file access
            len_0 = ::std::mem::size_of::<crate::stdlib::sockaddr_in>() as libc::c_ulong
                as crate::stdlib::socklen_t;
            crate::stdlib::getsockname(
                sock,
                &mut our_addr as *mut crate::stdlib::sockaddr_in as *mut crate::stdlib::sockaddr,
                &mut len_0,
            );
            if our_addr.sin_addr.s_addr == serv_addr.sin_addr.s_addr {
                if loglevel as libc::c_uint
                    >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint
                {
                    crate::src::utils::logprint(
                        b"%s %s:%d local player\n\x00" as *const u8 as *const libc::c_char,
                        crate::src::utils::logtime(),
                        (*::std::mem::transmute::<&[u8; 10], &[libc::c_char; 10]>(
                            b"slimproto\x00",
                        ))
                        .as_ptr(),
                        937 as libc::c_int,
                    );
                }
                crate::stdlib::strcat(
                    var_cap.as_mut_ptr(),
                    b",loc\x00" as *const u8 as *const libc::c_char,
                );
            }
            // add on any capablity to be sent to the new server
            if !new_server_cap.is_null() {
                crate::stdlib::strcat(var_cap.as_mut_ptr(), new_server_cap);
                crate::stdlib::free(new_server_cap as *mut libc::c_void);
                new_server_cap = 0 as *mut libc::c_char
            }
            sendHELO(reconnect, fixed_cap.as_mut_ptr(), var_cap.as_mut_ptr(), mac);
            slimproto_run();
            if !reconnect {
                reconnect = 1 as libc::c_int != 0
            }
            crate::stdlib::usleep(100000 as libc::c_int as crate::stdlib::__useconds_t);
        }
        previous_server = 0 as libc::c_int as crate::stdlib::in_addr_t;
        crate::stdlib::close(sock);
    }
}
/*
 *  Squeezelite - lightweight headless squeezebox emulator
 *
 *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
 *      Ralph Irving 2015-2017, ralph_irving@hotmail.com
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additions (c) Paul Hermann, 2015-2017 under the same license terms
 *   -Control of Raspberry pi GPIO for amplifier power
 *   -Launch script on power status change from LMS
 */
// make may define: PORTAUDIO, SELFPIPE, RESAMPLE, RESAMPLE_MP, VISEXPORT, GPIO, IR, DSD, LINKALL to influence build
// build detection
// dynamically loaded libraries at run time
// !LINKALL
// config options
// do not reduce as icy-meta max is 4080
/* SUN */
/* SUN */
// printf/scanf formats for u64_t
// logging
// utils.c (non logging)
// buffer.c
// _* called with mutex locked
// slimproto.c
#[no_mangle]

pub unsafe extern "C" fn slimproto_stop() {
    if loglevel as libc::c_uint >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint {
        crate::src::utils::logprint(
            b"%s %s:%d slimproto stop\n\x00" as *const u8 as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 15], &[libc::c_char; 15]>(b"slimproto_stop\x00"))
                .as_ptr(),
            966 as libc::c_int,
        );
    }
    running = 0 as libc::c_int != 0;
}
